#include <iprt/bldprog-strtab.h>

static const char g_achStrTabOidDbStrTab[] =
{
/* 0x00000 = "public-key-infrastructure" */
    'p','u','b','l','i','c','-','k','e','y','-','i','n','f','r','a','s','t','r','u','c','t','u','r','e',
/* 0x00019 = "Ms-License-and-Registration" */
    '\x01','L','i','c','e','n','s','e','-','a','n','d','-','R','e','g','i','s','t','r','a','t','i','o','n',
/* 0x00032 = "Ms-QualifiedSubordination" */
    '\x01','Q','u','a','l','i','f','i','e','d','S','u','b','o','r','d','i','n','a','t','i','o','n',
/* 0x00049 = "usa-computer-security-register" */
    '\x84','-','c','o','m','p','u','t','e','r','-','\x40','-','r','e','g','i','s','t','e','r',
/* 0x0005e = "Ms-SpcStructuredStorageData" */
    '\x01','\x11','S','t','r','u','c','t','u','r','e','d','S','t','o','r','a','g','e','\x12',
/* 0x00072 = "Ms-SpcIndividualCodeSigning" */
    '\x01','\x11','I','n','d','i','v','i','d','u','a','l','\x89','i','g','n','i','n','g',
/* 0x00085 = "Ms-DrmIndividualization" */
    '\x01','\xc8','I','n','d','i','v','i','d','u','a','l','i','z','a','t','i','o','n',
/* 0x00098 = "Ms-CertSrv-Infrastructure" */
    '\x01','\x1e','\xca','-','I','n','f','r','a','s','t','r','u','c','t','u','r','e',
/* 0x000aa = "pkcs9-challengePassword" */
    '\x02','c','h','a','l','l','e','n','g','e','P','a','s','s','w','o','r','d',
/* 0x000bc = "Ms-EnrollCerttypeExtension" */
    '\x01','\xa5','e','r','t','t','y','p','e','E','x','t','e','n','s','i','o','n',
/* 0x000ce = "apple-cs-ext-DevId-Application" */
    '\x23','\xb4','\x82','\x97','d','-','A','p','p','l','i','c','a','t','i','o','n',
/* 0x000df = "Ms-Outlook-Exchange" */
    '\x01','O','u','t','l','o','o','k','-','E','x','c','h','a','n','g','e',
/* 0x000f0 = "id-ce-KeyUsageRestriction-Deprecated" */
    '\x03','\x0f','\x1d','\x29','R','e','s','t','r','i','c','t','i','o','n','-','\x14',
/* 0x00101 = "pkcs9-at-SequenceNumber" */
    '\x02','\x58','S','e','q','u','e','n','c','e','N','u','m','b','e','r',
/* 0x00111 = "Ms-NextUpdateLocation" */
    '\x01','\xc0','U','p','d','a','t','e','L','o','c','a','t','i','o','n',
/* 0x00121 = "oiw-ssig-Md5WithRsaEncryption" */
    '\x1a','\x16','\x9a','i','t','h','\x10','n','c','r','y','p','t','i','o','n',
/* 0x00131 = "Ms-CertSrvPreviousCertHash" */
    '\x01','\x1e','\xca','P','r','e','v','i','o','u','s','\x1e','H','a','s','h',
/* 0x00141 = "oiw-ssig-Md2WithRsaEncryption" */
    '\x1a','\x16','\xbf','i','t','h','\x10','n','c','r','y','p','t','i','o','n',
/* 0x00151 = "oiw-ssig-Md4WithRsaEncryption" */
    '\x1a','\x16','\x99','i','t','h','\x10','n','c','r','y','p','t','i','o','n',
/* 0x00161 = "pkcs1-Md5WithRsaEncryption" */
    '\x09','\x9a','i','t','h','\x10','n','c','r','y','p','t','i','o','n',
/* 0x00170 = "x500-StatOrProvinceName" */
    '\x1c','S','t','a','t','\xfb','P','r','o','v','i','n','c','e','\x15',
/* 0x0017f = "pkcs1-Md4WithRsaEncryption" */
    '\x09','\x99','i','t','h','\x10','n','c','r','y','p','t','i','o','n',
/* 0x0018e = "pkcs1-Md2WithRsaEncryption" */
    '\x09','\xbf','i','t','h','\x10','n','c','r','y','p','t','i','o','n',
/* 0x0019d = "joint-iso/itu-t" */
    'j','o','i','n','t','-','i','s','o','/','i','t','u','-','t',
/* 0x001ac = "Ms-CertReqExtensions" */
    '\x01','\x1e','R','e','q','E','x','t','e','n','s','i','o','n','s',
/* 0x001bb = "apple-cs-ext-DevId-Installer" */
    '\x23','\xb4','\x82','\x97','d','-','I','n','s','t','a','l','l','e','r',
/* 0x001ca = "pkcs9-ct-TimestampTokenInfo" */
    '\x02','\x59','T','i','m','e','s','t','a','m','p','\xb3','n','f','o',
/* 0x001d9 = "Ms-SpcFinacialCriterialInfo" */
    '\x01','\x11','F','i','n','a','c','i','a','l','\x8c','n','f','o',
/* 0x001e7 = "id-kp-Timestamping" */
    '\x03','\x17','T','i','m','e','s','t','a','m','p','i','n','g',
/* 0x001f5 = "pkcs9-SMimeCapabilities" */
    '\x02','\x28','C','a','p','a','b','i','l','i','t','i','e','s',
/* 0x00203 = "pkcs9-ct-TimestampedData" */
    '\x02','\x59','T','i','m','e','s','t','a','m','p','e','d','\x12',
/* 0x00211 = "pkcs9-UnstructuredAddress" */
    '\x02','U','n','s','t','r','u','c','t','u','r','e','d','\xa2',
/* 0x0021f = "pkcs9-at-Pkcs15Token" */
    '\x02','\x58','P','k','c','s','1','5','T','o','k','e','n',
/* 0x0022c = "id-kp-OCSPSigning" */
    '\x03','\x17','O','C','S','P','S','i','g','n','i','n','g',
/* 0x00239 = "Ms-SpcMinimalCriterialInfo" */
    '\x01','\x11','M','i','n','i','m','a','l','\x8c','n','f','o',
/* 0x00246 = "ms-authenticode" */
    '\xb5','a','u','t','h','e','n','t','i','c','o','d','e',
/* 0x00253 = "id-kp-EmailProtection" */
    '\x03','\x17','\xf2','P','r','o','t','e','c','t','i','o','n',
/* 0x00260 = "Ms-SpcJavaClassDataType1" */
    '\x01','\x11','\xb9','l','a','s','s','\x12','T','y','p','e','1',
/* 0x0026d = "Ms-SpcCommericalSigning" */
    '\x01','\x11','C','o','m','m','e','r','i','c','a','l','\x0c',
/* 0x0027a = "pkcs9-at-RandomNonce" */
    '\x02','\x58','R','a','n','d','o','m','N','o','n','c','e',
/* 0x00287 = "ms-timestamping" */
    '\xb5','t','i','m','e','s','t','a','m','p','i','n','g',
/* 0x00294 = "pkcs9-ct-CompressedData" */
    '\x02','\x59','C','o','m','p','r','e','s','s','e','d','\x12',
/* 0x002a1 = "usa-company-arc" */
    '\x84','-','c','o','m','p','a','n','y','-','a','r','c',
/* 0x002ae = "DistributionP" */
    'D','i','s','t','r','i','b','u','t','i','o','n','P',
/* 0x002bb = "pkcs9-SigningDescription" */
    '\x02','\x0c','D','e','s','c','r','i','p','t','i','o','n',
/* 0x002c8 = "Ms-SortedCertTrustList" */
    '\x01','S','o','r','t','e','d','\x1e','\x81','i','s','t',
/* 0x002d4 = "verisign-pki-extensions" */
    '\x04','\x0d','e','x','t','e','n','s','i','o','n','s',
/* 0x002e0 = "Organization" */
    'O','r','g','a','n','i','z','a','t','i','o','n',
/* 0x002ec = "Ms-SpcIndirectDataContext" */
    '\x01','\x11','I','n','d','i','r','e','c','t','\x12','\xed',
/* 0x002f8 = "id-qt-TextNotice" */
    '\x03','\x83','T','e','x','t','N','o','t','i','c','e',
/* 0x00304 = "id-kp-SBGPCertAAServiceAuth" */
    '\x03','\x17','S','B','G','P','C','e','r','t','\xe9','\x22',
/* 0x00310 = "id-ce-PrivateKeyUsagePeriod" */
    '\x03','\x0f','\x9f','e','y','\x29','P','e','r','i','o','d',
/* 0x0031c = "security-Mechanisms" */
    '\x40','-','M','e','c','h','a','n','i','s','m','s',
/* 0x00328 = "id-ce-issuerAltName" */
    '\x03','\x0f','i','s','s','u','e','r','\x60','a','m','e',
/* 0x00334 = "verisign-pki-ext-RolloverID" */
    '\x04','\x0d','\x82','R','o','l','l','o','v','e','r','\xe8',
/* 0x00340 = "Ms-SpcStatementType" */
    '\x01','\x11','S','t','a','t','e','m','e','n','t','\x9e',
/* 0x0034c = "pkcs9-id-aa-signingCertificateV2" */
    '\x02','\x03','\x93','s','i','g','n','i','n','g','\x0e','\xcc',
/* 0x00358 = "Ms-SpcLinkType2-Aka-CabData" */
    '\x01','\x11','\xba','y','p','e','2','-','\xd2','-','\xda','\x12',
/* 0x00364 = "usa-goverment" */
    '\x84','-','g','o','v','e','r','m','e','n','t',
/* 0x0036f = "Certificate" */
    'C','e','r','t','i','f','i','c','a','t','e',
/* 0x0037a = "verisign-pki-eku-IssStrongCrypto" */
    '\x04','\x0d','\xa1','\xf6','S','t','r','o','n','g','\x19',
/* 0x00385 = "Ms-EmbeddedNtCrypto" */
    '\x01','E','m','b','e','d','d','e','d','\xf8','\x19',
/* 0x00390 = "Ms-Serialized" */
    '\x01','S','e','r','i','a','l','i','z','e','d',
/* 0x0039b = "pkcs1-Sha224WithRsaEncryption" */
    '\x09','S','h','a','2','2','4','\x0a','s','a','\x06',
/* 0x003a6 = "pkcs9-ExtendedCertificateAttributes" */
    '\x02','E','x','t','e','n','d','e','d','\x0e','\x2a',
/* 0x003b1 = "pkcs1-RsaEncryption" */
    '\x09','\x10','n','c','r','y','p','t','i','o','n',
/* 0x003bc = "Ms-PKCS12-LocalMachineKeyset" */
    '\x01','\xa8','\xff','M','a','c','h','i','n','e','\xfe',
/* 0x003c7 = "pkcs7-encryptedData" */
    '\x1b','e','n','c','r','y','p','t','e','d','\x12',
/* 0x003d2 = "verisign-pki-policy-vtn-cp-class4" */
    '\x04','\x0d','\x08','\x2c','\x3c','c','l','a','s','s','4',
/* 0x003dd = "pkcs7-envelopedData" */
    '\x1b','e','n','v','e','l','o','p','e','d','\x12',
/* 0x003e8 = "pkcs1-Sha256WithRsaEncryption" */
    '\x09','S','h','a','2','5','6','\x0a','s','a','\x06',
/* 0x003f3 = "pkcs1-Sha384WithRsaEncryption" */
    '\x09','S','h','a','3','8','4','\x0a','s','a','\x06',
/* 0x003fe = "pkcs9-UntrustedName" */
    '\x02','U','n','t','r','u','s','t','e','d','\x15',
/* 0x00409 = "netscape-cert-renewal-url" */
    '\x07','\x8f','r','e','n','e','w','a','l','-','\x5a',
/* 0x00414 = "revocation-" */
    'r','e','v','o','c','a','t','i','o','n','-',
/* 0x0041f = "id-ce-CertificatePolicies" */
    '\x03','\x0f','\x0e','P','o','l','i','c','i','e','s',
/* 0x0042a = "netscape-ssl-server-name" */
    '\x07','s','s','l','-','\xb6','-','n','a','m','e',
/* 0x00435 = "verisign-pki-policy-vtn-cp-class1" */
    '\x04','\x0d','\x08','\x2c','\x3c','c','l','a','s','s','1',
/* 0x00440 = "verisign-pki-policy-vtn-cp-class2" */
    '\x04','\x0d','\x08','\x2c','\x3c','c','l','a','s','s','2',
/* 0x0044b = "verisign-pki-policy-vtn-cp-class3" */
    '\x04','\x0d','\x08','\x2c','\x3c','c','l','a','s','s','3',
/* 0x00456 = "Constraints" */
    'C','o','n','s','t','r','a','i','n','t','s',
/* 0x00461 = "pkcs7-digestedData" */
    '\x1b','d','i','g','e','s','t','e','d','\x12',
/* 0x0046b = "x500-LocalityName" */
    '\x1c','L','o','c','a','l','i','t','y','\x15',
/* 0x00475 = "ExtensionR" */
    'E','x','t','e','n','s','i','o','n','R',
/* 0x0047f = "Ms-CertificateTemplate" */
    '\x01','\x0e','T','e','m','p','l','a','t','e',
/* 0x00489 = "pkcs9-CounterSignature" */
    '\x02','\x96','i','g','n','a','t','u','r','e',
/* 0x00493 = "Ms-TrustedCodeSigningCAList" */
    '\x01','\x5c','\x89','i','g','n','i','n','g','\x7b',
/* 0x0049d = "Ms-DocumentSigning" */
    '\x01','D','o','c','u','m','e','n','t','\x0c',
/* 0x004a7 = "by-country" */
    'b','y','-','c','o','u','n','t','r','y',
/* 0x004b1 = "CriterialI" */
    'C','r','i','t','e','r','i','a','l','I',
/* 0x004bb = "algorithms" */
    'a','l','g','o','r','i','t','h','m','s',
/* 0x004c5 = "EnvelopedD" */
    'E','n','v','e','l','o','p','e','d','D',
/* 0x004cf = "nist-id-rsassa-pkcs1-v1-5-with-sha3-224" */
    '\x05','\x03','\x26','\x09','\x95','5','-','\x0b','\x13','\x5e',
/* 0x004d9 = "Ms-CrlVirtualBase" */
    '\x01','\x90','V','i','r','t','u','a','l','\xd6',
/* 0x004e3 = "nist-id-rsassa-pkcs1-v1-5-with-sha3-256" */
    '\x05','\x03','\x26','\x09','\x95','5','-','\x0b','\x13','\x5f',
/* 0x004ed = "nist-id-rsassa-pkcs1-v1-5-with-sha3-384" */
    '\x05','\x03','\x26','\x09','\x95','5','-','\x0b','\x13','\xab',
/* 0x004f7 = "nist-id-rsassa-pkcs1-v1-5-with-sha3-512" */
    '\x05','\x03','\x26','\x09','\x95','5','-','\x0b','\x13','\xac',
/* 0x00501 = "Encryption" */
    'E','n','c','r','y','p','t','i','o','n',
/* 0x0050b = "Deprecated" */
    'D','e','p','r','e','c','a','t','e','d',
/* 0x00515 = "apple-eku-packageSign" */
    '\x23','\xa1','p','a','c','k','a','g','e','\xc1',
/* 0x0051f = "Ms-LifetimeSigning" */
    '\x01','L','i','f','e','t','i','m','e','\x0c',
/* 0x00529 = "pkcs9-at-Pkcs7PDU" */
    '\x02','\x58','P','k','c','s','7','P','D','U',
/* 0x00533 = "verisign-pki-policies" */
    '\x04','\x0d','p','o','l','i','c','i','e','s',
/* 0x0053d = "Ms-SpcPeImagePageHashesV1" */
    '\x01','\x11','\xb0','m','a','g','e','\x9b','\xa6','1',
/* 0x00547 = "Ms-SpcPeImagePageHashesV2" */
    '\x01','\x11','\xb0','m','a','g','e','\x9b','\xa6','2',
/* 0x00551 = "Ms-CrlNextPublish" */
    '\x01','\x90','\xc0','P','u','b','l','i','s','h',
/* 0x0055b = "Attributes" */
    'A','t','t','r','i','b','u','t','e','s',
/* 0x00565 = "Identifier" */
    'I','d','e','n','t','i','f','i','e','r',
/* 0x0056f = "netscape-eku-serverGatedCrypto" */
    '\x07','\xa1','\xb6','\xad','r','y','p','t','o',
/* 0x00578 = "Ms-CaKeyCertIndexPair" */
    '\x01','\xd9','\x1d','\x1e','\xfc','P','a','i','r',
/* 0x00581 = "nist-shake128" */
    '\x05','s','h','a','k','e','1','2','8',
/* 0x0058a = "Authority" */
    'A','u','t','h','o','r','i','t','y',
/* 0x00593 = "verisign-" */
    'v','e','r','i','s','i','g','n','-',
/* 0x0059c = "verisign-pki-policy-thawte-cps-1" */
    '\x04','\x0d','\x08','\xaa','c','p','s','-','1',
/* 0x005a5 = "verisign-pki-policy-cis-type1" */
    '\x04','\x0d','\x08','\xa0','t','y','p','e','1',
/* 0x005ae = "Ms-SpcNestedSignature" */
    '\x01','\x11','N','e','s','t','e','d','\x92',
/* 0x005b7 = "microsoft" */
    'm','i','c','r','o','s','o','f','t',
/* 0x005c0 = "pkcs9-MessageDigest" */
    '\x02','M','e','s','s','a','g','e','\xef',
/* 0x005c9 = "id-ce-CertificateIssuer" */
    '\x03','\x0f','\x0e','I','s','s','u','e','r',
/* 0x005d2 = "id-qt-UNotice" */
    '\x03','\x83','U','N','o','t','i','c','e',
/* 0x005db = "ACUNotice" */
    'A','C','U','N','o','t','i','c','e',
/* 0x005e4 = "netscape-" */
    'n','e','t','s','c','a','p','e','-',
/* 0x005ed = "netscape-UserPicture" */
    '\x07','\xc2','P','i','c','t','u','r','e',
/* 0x005f6 = "verisign-pki-policy-cis-type2" */
    '\x04','\x0d','\x08','\xa0','t','y','p','e','2',
/* 0x005ff = "id-ce-SubjectAltName-Deprecated" */
    '\x03','\x0f','\x5b','\x60','a','m','e','-','\x14',
/* 0x00608 = "Encrypted" */
    'E','n','c','r','y','p','t','e','d',
/* 0x00611 = "nist-shake256" */
    '\x05','s','h','a','k','e','2','5','6',
/* 0x0061a = "id-kp-CodeSigning" */
    '\x03','\x17','\x89','i','g','n','i','n','g',
/* 0x00623 = "Signature" */
    'S','i','g','n','a','t','u','r','e',
/* 0x0062c = "verisign-pki-policy-thawte" */
    '\x04','\x0d','\x08','t','h','a','w','t','e',
/* 0x00635 = "oiw-ssig-Md5WithRsa" */
    '\x1a','\x16','\x9a','i','t','h','R','s','a',
/* 0x0063e = "AAService" */
    'A','A','S','e','r','v','i','c','e',
/* 0x00647 = "attribute" */
    'a','t','t','r','i','b','u','t','e',
/* 0x00650 = "id-ce-CrlDistributionPoints" */
    '\x03','\x0f','\x90','\x5d','o','i','n','t','s',
/* 0x00659 = "oiw-ssig-Md4WithRsa" */
    '\x1a','\x16','\x99','i','t','h','R','s','a',
/* 0x00662 = "dod-Internet" */
    '\xc3','I','n','t','e','r','n','e','t',
/* 0x0066b = "id-kp-IPSecTunnel" */
    '\x03','\x17','\x8a','T','u','n','n','e','l',
/* 0x00674 = "oiw-ssig-ShaWithRsaEncryption" */
    '\x1a','\x16','S','h','a','\x0a','s','a','\x06',
/* 0x0067d = "Policies-" */
    'P','o','l','i','c','i','e','s','-',
/* 0x00686 = "apple-cert-policy" */
    '\x23','\x8f','p','o','l','i','c','y',
/* 0x0068e = "Ms-ServerGatedCrypto" */
    '\x01','\x7d','\xad','r','y','p','t','o',
/* 0x00696 = "pkcs9-ExtensionRequest" */
    '\x02','\x8e','e','q','u','e','s','t',
/* 0x0069e = "netscape-comment" */
    '\x07','c','o','m','m','e','n','t',
/* 0x006a6 = "security" */
    's','e','c','u','r','i','t','y',
/* 0x006ae = "Certtype" */
    'C','e','r','t','t','y','p','e',
/* 0x006b6 = "Ms-CatNameValue" */
    '\x01','\xc6','\x15','V','a','l','u','e',
/* 0x006be = "pkcs1-Sha512-224WithRsaEncryption" */
    '\x09','\x7e','-','\x5e','\x0a','s','a','\x06',
/* 0x006c6 = "x500-attribute-types" */
    '\x1c','\x94','-','t','y','p','e','s',
/* 0x006ce = "Recovery" */
    'R','e','c','o','v','e','r','y',
/* 0x006d6 = "Ms-SpcPeImageData" */
    '\x01','\x11','\xb0','m','a','g','e','\x12',
/* 0x006de = "pkcs1-Sha512-256WithRsaEncryption" */
    '\x09','\x7e','-','\x5f','\x0a','s','a','\x06',
/* 0x006e6 = "Ms-OemWhqlCrypto" */
    '\x01','\xfa','\xbd','r','y','p','t','o',
/* 0x006ee = "Ms-kp-CertTrustListSigning" */
    '\x01','\x17','\x1e','\x81','i','s','t','\x0c',
/* 0x006f6 = "CounterS" */
    'C','o','u','n','t','e','r','S',
/* 0x006fe = "apple-cs-ext-DevId-KernelExt" */
    '\x23','\xb4','\x82','\x97','d','-','\xfd','\xc9',
/* 0x00706 = "PrivateK" */
    'P','r','i','v','a','t','e','K',
/* 0x0070e = "id-ce-IssuerAltName-Deprecated" */
    '\x03','\x0f','\xa7','l','t','\x15','-','\x14',
/* 0x00716 = "EnrollC" */
    'E','n','r','o','l','l','C',
/* 0x0071d = "Address" */
    'A','d','d','r','e','s','s',
/* 0x00724 = "Ms-WhqlCrypto" */
    '\x01','\xbd','r','y','p','t','o',
/* 0x0072b = "Context" */
    'C','o','n','t','e','x','t',
/* 0x00732 = "IssuerA" */
    'I','s','s','u','e','r','A',
/* 0x00739 = "EAPOver" */
    'E','A','P','O','v','e','r',
/* 0x00740 = "HashesV" */
    'H','a','s','h','e','s','V',
/* 0x00747 = "ClientA" */
    'C','l','i','e','n','t','A',
/* 0x0074e = "thawte-" */
    't','h','a','w','t','e','-',
/* 0x00755 = "PKCS12-" */
    'P','K','C','S','1','2','-',
/* 0x0075c = "Request" */
    'R','e','q','u','e','s','t',
/* 0x00763 = "pkcs9-ct-AuthEnvelopedData" */
    '\x02','\x59','\x22','\x8d','a','t','a',
/* 0x0076a = "pkcs7-signedAndEnvelopedData" */
    '\x1b','\xb7','\xd4','\x8d','a','t','a',
/* 0x00771 = "Ms-SpcLinkType3" */
    '\x01','\x11','\xba','y','p','e','3',
/* 0x00778 = "Content" */
    'C','o','n','t','e','n','t',
/* 0x0077f = "Trusted" */
    'T','r','u','s','t','e','d',
/* 0x00786 = "rsassa-" */
    'r','s','a','s','s','a','-',
/* 0x0078d = "Ms-RootListSigner" */
    '\x01','R','o','o','t','\x27','\xb2',
/* 0x00794 = "Country" */
    'C','o','u','n','t','r','y',
/* 0x0079b = "Ms-SpcRawFileData" */
    '\x01','\x11','R','a','w','\x98','\x12',
/* 0x007a2 = "policy-" */
    'p','o','l','i','c','y','-',
/* 0x007a9 = "pkcs1-RsaPss" */
    '\x09','R','s','a','P','s','s',
/* 0x007b0 = "id-ce-cp-anyPolicy" */
    '\x03','\x0f','\x3c','a','n','y','\xb1',
/* 0x007b7 = "Subject" */
    'S','u','b','j','e','c','t',
/* 0x007be = "Ms-SpcOpusInfo" */
    '\x01','\x11','O','p','u','s','\x18',
/* 0x007c5 = "nist-hash-algorithms" */
    '\x05','h','a','s','h','-','\x1f',
/* 0x007cc = "oiw-ssig-Sha1WithRsaEncryption" */
    '\x1a','\x16','\x9c','\x0a','s','a','\x06',
/* 0x007d3 = "Catalog" */
    'C','a','t','a','l','o','g',
/* 0x007da = "pkcs9-at-EncryptedPrivateKeyInfo" */
    '\x02','\x58','\x3b','\x9f','e','y','\x18',
/* 0x007e1 = "id-ce-AuthorityKeyIdentifier-Deprecated" */
    '\x03','\x0f','\x3a','\x1d','\x2b','-','\x14',
/* 0x007e8 = "Ms-TrustedClientAuthCAList" */
    '\x01','\x5c','\xa3','u','t','h','\x7b',
/* 0x007ef = "netscape-base-url" */
    '\x07','b','a','s','e','-','\x5a',
/* 0x007f6 = "x500-OrganizationUnitName" */
    '\x1c','\x80','U','n','i','t','\x15',
/* 0x007fd = "pkcs1-Sha512WithRsaEncryption" */
    '\x09','\x7e','\x0a','s','a','\x06',
/* 0x00803 = "verisign-pki-policy-vtn-cp" */
    '\x04','\x0d','\x08','\x2c','c','p',
/* 0x00809 = "Signer" */
    'S','i','g','n','e','r',
/* 0x0080f = "pkcs9-SMime-id-aa" */
    '\x02','\x28','-','\x03','a','a',
/* 0x00815 = "Agency" */
    'A','g','e','n','c','y',
/* 0x0081b = "pkcs1-" */
    'p','k','c','s','1','-',
/* 0x00821 = "nist-aes-algorithms" */
    '\x05','a','e','s','-','\x1f',
/* 0x00827 = "id-kp-ClientAuth" */
    '\x03','\x17','\xa3','u','t','h',
/* 0x0082d = "Points" */
    'P','o','i','n','t','s',
/* 0x00833 = "GatedC" */
    'G','a','t','e','d','C',
/* 0x00839 = "id-kp-EAPOverPPP" */
    '\x03','\x17','\xa4','P','P','P',
/* 0x0083f = "nist-id-ecdsa-with-sha3-512" */
    '\x05','\x03','\x3d','\x0b','\x13','\xac',
/* 0x00845 = "Access" */
    'A','c','c','e','s','s',
/* 0x0084b = "Keyset" */
    'K','e','y','s','e','t',
/* 0x00851 = "Common" */
    'C','o','m','m','o','n',
/* 0x00857 = "pkcs1-Sha1WithRsaEncryption" */
    '\x09','\x9c','\x0a','s','a','\x06',
/* 0x0085d = "Server" */
    'S','e','r','v','e','r',
/* 0x00863 = "Ms-SpcHashInfo" */
    '\x01','\x11','\xb8','n','f','o',
/* 0x00869 = "Sha512" */
    'S','h','a','5','1','2',
/* 0x0086f = "verisign-pki-policy-cis" */
    '\x04','\x0d','\x08','c','i','s',
/* 0x00875 = "TrustL" */
    'T','r','u','s','t','L',
/* 0x0087b = "Policy" */
    'P','o','l','i','c','y',
/* 0x00881 = "Entity" */
    'E','n','t','i','t','y',
/* 0x00887 = "sha224" */
    's','h','a','2','2','4',
/* 0x0088d = "Ms-EncryptedFileSystem-Recovery" */
    '\x01','\x3b','\x98','\x7f','-','\x3e',
/* 0x00893 = "ecdsa-" */
    'e','c','d','s','a','-',
/* 0x00899 = "Ms-CertTrustList" */
    '\x01','\x1e','\x81','i','s','t',
/* 0x0089f = "Kernel" */
    'K','e','r','n','e','l',
/* 0x008a5 = "Member" */
    'M','e','m','b','e','r',
/* 0x008ab = "Ms-SpcSipInfo" */
    '\x01','\x11','S','i','p','\x18',
/* 0x008b1 = "sha384" */
    's','h','a','3','8','4',
/* 0x008b7 = "server" */
    's','e','r','v','e','r',
/* 0x008bd = "Ms-AutoEnrollCtlUsage" */
    '\x01','\xd5','\xa5','t','l','\x29',
/* 0x008c3 = "netscape-EntityLogo" */
    '\x07','\xf3','L','o','g','o',
/* 0x008c9 = "nist-id-ecdsa-with-sha3-384" */
    '\x05','\x03','\x3d','\x0b','\x13','\xab',
/* 0x008cf = "sha512" */
    's','h','a','5','1','2',
/* 0x008d5 = "nist-id-ecdsa-with-sha3-224" */
    '\x05','\x03','\x3d','\x0b','\x13','\x5e',
/* 0x008db = "id-ce-KeyAttributes-Deprecated" */
    '\x03','\x0f','\x1d','\x2a','-','\x14',
/* 0x008e1 = "rsadsi" */
    'r','s','a','d','s','i',
/* 0x008e7 = "pkcs9-" */
    'p','k','c','s','9','-',
/* 0x008ed = "netscape-cert-type" */
    '\x07','\x8f','t','y','p','e',
/* 0x008f3 = "CAList" */
    'C','A','L','i','s','t',
/* 0x008f9 = "nist-id-ecdsa-with-sha3-256" */
    '\x05','\x03','\x3d','\x0b','\x13','\x5f',
/* 0x008ff = "signed" */
    's','i','g','n','e','d',
/* 0x00905 = "verisign-pki-policy-vtn-cp-6" */
    '\x04','\x0d','\x08','\x2c','\x3c','6',
/* 0x0090b = "TokenI" */
    'T','o','k','e','n','I',
/* 0x00911 = "Digest" */
    'D','i','g','e','s','t',
/* 0x00917 = "apple-" */
    'a','p','p','l','e','-',
/* 0x0091d = "System" */
    'S','y','s','t','e','m',
/* 0x00923 = "sha256" */
    's','h','a','2','5','6',
/* 0x00929 = "pkcs7-" */
    'p','k','c','s','7','-',
/* 0x0092f = "Crypto" */
    'C','r','y','p','t','o',
/* 0x00935 = "Class" */
    'C','l','a','s','s',
/* 0x0093a = "Ms-CorpPKI" */
    '\x01','\xe1','P','K','I',
/* 0x0093f = "CodeS" */
    'C','o','d','e','S',
/* 0x00944 = "Index" */
    'I','n','d','e','x',
/* 0x00949 = "LinkT" */
    'L','i','n','k','T',
/* 0x0094e = "Ms-Catalog-dot-2" */
    '\x01','\x20','-','\xc4','2',
/* 0x00953 = "Ms-Catalog-dot-1" */
    '\x01','\x20','-','\xc4','1',
/* 0x00958 = "id-ce-ExtKeyUsage" */
    '\x03','\x0f','\xc9','\x1d','\x29',
/* 0x0095d = "pkcs9-SMime-ct" */
    '\x02','\x28','-','c','t',
/* 0x00962 = "id-ce-SubjectKeyIdentifier" */
    '\x03','\x0f','\x5b','\x1d','\x2b',
/* 0x00967 = "Ms-TrustedServerAuthCAList" */
    '\x01','\x5c','\x7d','\x22','\x7b',
/* 0x0096c = "Fonts" */
    'F','o','n','t','s',
/* 0x00971 = "with-" */
    'w','i','t','h','-',
/* 0x00976 = "pkix-" */
    'p','k','i','x','-',
/* 0x0097b = "nist-sigAlgs" */
    '\x05','s','i','g','\xd3',
/* 0x00980 = "asn.1" */
    'a','s','n','.','1',
/* 0x00985 = "pkix-LogoType" */
    '\xbe','\xbb','y','p','e',
/* 0x0098a = "Ms-CounterSign" */
    '\x01','\x96','i','g','n',
/* 0x0098f = "nist-id-dsa-with-sha512" */
    '\x05','\x03','\x21','\x0b','\x24',
/* 0x00994 = "netscape-HomePage-url" */
    '\x07','\xf5','\x9b','-','\x5a',
/* 0x00999 = "Usage" */
    'U','s','a','g','e',
/* 0x0099e = "x500-" */
    'x','5','0','0','-',
/* 0x009a3 = "IPSec" */
    'I','P','S','e','c',
/* 0x009a8 = "Ms-kp-TimeStampSigning" */
    '\x01','\x17','\x9d','\xbc','\x0c',
/* 0x009ad = "Email" */
    'E','m','a','i','l',
/* 0x009b2 = "id-kp-IPSecEndSystem" */
    '\x03','\x17','\x8a','\xe7','\x7f',
/* 0x009b7 = "pkcs9-SMime-at" */
    '\x02','\x28','-','a','t',
/* 0x009bc = "Image" */
    'I','m','a','g','e',
/* 0x009c1 = "SMime" */
    'S','M','i','m','e',
/* 0x009c6 = "Cross" */
    'C','r','o','s','s',
/* 0X009cb = "ssig-" */
    'i','g','-',
/* 0x009ce = "Ms-SpcTimeStampRequest" */
    '\x01','\x11','\x9d','\xbc','\xa9',
/* 0x009d3 = "Dummy" */
    'D','u','m','m','y',
/* 0x009d8 = "nist-" */
    'n','i','s','t','-',
/* 0x009dd = "sha3-" */
    's','h','a','3','-',
/* 0x009e2 = "Stamp" */
    'S','t','a','m','p',
/* 0x009e7 = "WithR" */
    'W','i','t','h','R',
/* 0x009ec = "pkcs9-id-aa-SigningCertificate" */
    '\x02','\x03','\x93','\x0c','\x0e',
/* 0x009f1 = "Ms-CrossCertDistPoints" */
    '\x01','\xe3','\x1e','\xe5','\x7c',
/* 0x009f6 = "WhqlC" */
    'W','h','q','l','C',
/* 0x009fb = "oiw-ssig" */
    '\x1a','s','s','i','g',
/* 0x00a00 = "JavaC" */
    'J','a','v','a','C',
/* 0x00a05 = "pkcs7-data" */
    '\x1b','d','a','t','a',
/* 0x00a0a = "nist-id-dsa-with-sha256" */
    '\x05','\x03','\x21','\x0b','\x86',
/* 0x00a0f = "nist-id-dsa-with-sha224" */
    '\x05','\x03','\x21','\x0b','\x85',
/* 0x00a14 = "Ms-Java" */
    '\x01','J','a','v','a',
/* 0x00a19 = "nist-id-dsa-with-sha384" */
    '\x05','\x03','\x21','\x0b','\x87',
/* 0x00a1e = "id-ce-CertificatePolicies-Deprecated" */
    '\x03','\x0f','\x0e','\x91','\x14',
/* 0x00a23 = "LogoT" */
    'L','o','g','o','T',
/* 0x00a28 = "cert-" */
    'c','e','r','t','-',
/* 0x00a2d = "Basic" */
    'B','a','s','i','c',
/* 0x00a32 = "HashI" */
    'H','a','s','h','I',
/* 0x00a37 = "EMail" */
    'E','M','a','i','l',
/* 0x00a3c = "netscape-ca-revocation-url" */
    '\x07','\xcb','\x88','\x5a',
/* 0x00a40 = "Capi" */
    'C','a','p','i',
/* 0x00a44 = "Corp" */
    'C','o','r','p',
/* 0x00a48 = "Auto" */
    'A','u','t','o',
/* 0x00a4c = "Ms-CatMemberInfo" */
    '\x01','\xc6','\xaf','\x18',
/* 0x00a50 = "pkcs9-ct-AuthData" */
    '\x02','\x59','\x22','\x12',
/* 0x00a54 = "nist-dsa-with-sha384" */
    '\x05','\x21','\x0b','\x87',
/* 0x00a58 = "nist-dsa-with-sha256" */
    '\x05','\x21','\x0b','\x86',
/* 0x00a5c = "Ms-Ctl-CAs" */
    '\x01','\xc7','-','\xd7',
/* 0x00a60 = ".2.4" */
    '.','2','.','4',
/* 0x00a64 = "nist-dsa-with-sha224" */
    '\x05','\x21','\x0b','\x85',
/* 0x00a68 = "Ms-SpcAgencyInfo" */
    '\x01','\x11','\xdc','\x18',
/* 0x00a6c = "verisign-pki-policy-21" */
    '\x04','\x0d','\x08','\xcf',
/* 0x00a70 = "verisign-pki" */
    '\x04','p','k','i',
/* 0x00a74 = "nist-dsa-with-sha512" */
    '\x05','\x21','\x0b','\x24',
/* 0x00a78 = "id-kp-EAPOverLAN" */
    '\x03','\x17','\xa4','\xf7',
/* 0x00a7c = "Md4W" */
    'M','d','4','W',
/* 0x00a80 = "pki-" */
    'p','k','i','-',
/* 0x00a84 = "Home" */
    'H','o','m','e',
/* 0x00a88 = "verisign-pki-policy-9" */
    '\x04','\x0d','\x08','9',
/* 0x00a8c = "Ms-CatalogListMember" */
    '\x01','\x20','\x27','\xaf',
/* 0x00a90 = "DevI" */
    'D','e','v','I',
/* 0x00a94 = "id-kp-IPSecUser" */
    '\x03','\x17','\x8a','\xc2',
/* 0x00a98 = "dot-" */
    'd','o','t','-',
/* 0x00a9c = "pkix-AuthorityInfoAccess" */
    '\xbe','\x3a','\x18','\xdb',
/* 0x00aa0 = "Base" */
    'B','a','s','e',
/* 0x00aa4 = "Algs" */
    'A','l','g','s',
/* 0x00aa8 = "nist-sha512-224" */
    '\x05','\x24','-','\x5e',
/* 0x00aac = "DVCS" */
    'D','V','C','S',
/* 0x00ab0 = "ext-" */
    'e','x','t','-',
/* 0x00ab4 = "Data" */
    'D','a','t','a',
/* 0x00ab8 = "File" */
    'F','i','l','e',
/* 0x00abc = "dod-" */
    'd','o','d','-',
/* 0x00ac0 = "User" */
    'U','s','e','r',
/* 0x00ac4 = "cis-" */
    'c','i','s','-',
/* 0x00ac8 = "oiw-" */
    'o','i','w','-',
/* 0x00acc = "Page" */
    'P','a','g','e',
/* 0x00ad0 = "ACPS" */
    'A','C','P','S',
/* 0X00ad4 = "Sha1" */
    'h','a','1',
/* 0x00ad7 = "Ms-?-3.2" */
    '\x01','?','-','\xd0',
/* 0x00adb = "vtn-" */
    'v','t','n','-',
/* 0x00adf = "nist-sha512-256" */
    '\x05','\x24','-','\x5f',
/* 0x00ae3 = "Md5W" */
    'M','d','5','W',
/* 0x00ae7 = "netscape-ca-policy-url" */
    '\x07','\xcb','\x08','\x5a',
/* 0x00aeb = "Name" */
    'N','a','m','e',
/* 0x00aef = "Info" */
    'I','n','f','o',
/* 0x00af3 = "RsaE" */
    'R','s','a','E',
/* 0x00af7 = "id-ce-NameConstraints" */
    '\x03','\x0f','\x15','\x25',
/* 0x00afb = "Next" */
    'N','e','x','t',
/* 0x00aff = "Md2W" */
    'M','d','2','W',
/* 0x00b03 = "id-kp-ServerAuth" */
    '\x03','\x17','\x7d','\x22',
/* 0x00b07 = "eku-" */
    'e','k','u','-',
/* 0x00b0b = "ms-spc" */
    '\xb5','s','p','c',
/* 0x00b0f = "id-ce-BasicConstraints" */
    '\x03','\x0f','\xdd','\x25',
/* 0x00b13 = "pkcs9-id-aa-Attributes" */
    '\x02','\x03','\x93','\x2a',
/* 0x00b17 = "AltN" */
    'A','l','t','N',
/* 0x00b1b = "id-ce-PolicyConstraints" */
    '\x03','\x0f','\xb1','\x25',
/* 0x00b1f = "Ms-CapiCom" */
    '\x01','\xde','\xdf',
/* 0x00b22 = "Spc" */
    'S','p','c',
/* 0x00b25 = "pkcs7-signedData" */
    '\x1b','\xb7','\x12',
/* 0x00b28 = "x500-CommonName" */
    '\x1c','\xe2','\x15',
/* 0x00b2b = "Ms-KeyRecovery" */
    '\x01','\x1d','\x3e',
/* 0x00b2e = "Ms-??-2.1" */
    '\x01','\xc5','\xce',
/* 0x00b31 = "Ms-??-.2.4" */
    '\x01','\xc5','\xcd',
/* 0x00b34 = "Crl" */
    'C','r','l',
/* 0x00b37 = "Srv" */
    'S','r','v',
/* 0x00b3a = "Ms-Nt5Crypto" */
    '\x01','\xf9','\x19',
/* 0x00b3d = "Cab" */
    'C','a','b',
/* 0x00b40 = "Drm" */
    'D','r','m',
/* 0x00b43 = "2.1" */
    '2','.','1',
/* 0x00b46 = "ca-" */
    'c','a','-',
/* 0x00b49 = "nist-sha3-512" */
    '\x05','\x13','\xac',
/* 0x00b4c = "PeI" */
    'P','e','I',
/* 0X00b4f = "Id-" */
    'd','-',
/* 0x00b51 = "Ctl" */
    'C','t','l',
/* 0x00b54 = "cs-" */
    'c','s','-',
/* 0x00b57 = "x500-CountryName" */
    '\x1c','\xee','\x15',
/* 0x00b5a = "nist-sha3-256" */
    '\x05','\x13','\x5f',
/* 0x00b5d = "And" */
    'A','n','d',
/* 0x00b60 = "oiw-ssig-algorithms" */
    '\x1a','\x16','\x1f',
/* 0x00b63 = "ct-" */
    'c','t','-',
/* 0x00b66 = "url" */
    'u','r','l',
/* 0x00b69 = "CAs" */
    'C','A','s',
/* 0x00b6c = "Ms-" */
    'M','s','-',
/* 0x00b6f = "usa" */
    'u','s','a',
/* 0x00b72 = "ms-" */
    'm','s','-',
/* 0x00b75 = "id-kp-DVCS" */
    '\x03','\x17','\xe4',
/* 0x00b78 = "id-" */
    'i','d','-',
/* 0x00b7b = "nist-sha3-224" */
    '\x05','\x13','\x5e',
/* 0x00b7e = "3.2" */
    '3','.','2',
/* 0x00b81 = "nist-sha3-384" */
    '\x05','\x13','\xab',
/* 0x00b84 = "id-ce" */
    '\x03','c','e',
/* 0x00b87 = "pkcs9-EMailAddress" */
    '\x02','\xf1','\xa2',
/* 0x00b8a = "qt-" */
    'q','t','-',
/* 0x00b8d = "v1-" */
    'v','1','-',
/* 0x00b90 = "at-" */
    'a','t','-',
/* 0x00b93 = "pkcs9-SigningTime" */
    '\x02','\x0c','\x9d',
/* 0x00b96 = "Oem" */
    'O','e','m',
/* 0x00b99 = "Aka" */
    'A','k','a',
/* 0X00b9c = "aa-" */
    'a','-',
/* 0x00b9e = "kp-" */
    'k','p','-',
/* 0x00ba1 = "Ms-DummySigner" */
    '\x01','\xf0','\xb2',
/* 0x00ba4 = "cp-" */
    'c','p','-',
/* 0x00ba7 = "netscape-revocation-url" */
    '\x07','\x88','\x5a',
/* 0x00baa = "EKU" */
    'E','K','U',
/* 0x00bad = "End" */
    'E','n','d',
/* 0x00bb0 = "x500-OrganizationName" */
    '\x1c','\x80','\x15',
/* 0x00bb3 = "??-" */
    '?','?','-',
/* 0x00bb6 = "Ms-PKCS12-attribute" */
    '\x01','\xa8','\x94',
/* 0x00bb9 = "id-qt-CPS" */
    '\x03','\x83','\xd8',
/* 0x00bbc = "id-qt-ACPS" */
    '\x03','\x83','\xd1',
/* 0x00bbf = "Nt5" */
    'N','t','5',
/* 0x00bc2 = "id-qt-ACUNotice" */
    '\x03','\x83','\xea',
/* 0x00bc5 = "ce-" */
    'c','e','-',
/* 0x00bc8 = "pkcs9-ContentType" */
    '\x02','\xec','\x9e',
/* 0x00bcb = "LAN" */
    'L','A','N',
/* 0x00bce = "Ms-EKU" */
    '\x01','\xe6',
/* 0x00bd0 = "Ms-Fonts" */
    '\x01','\xf4',
/* 0x00bd2 = "nist-sha384" */
    '\x05','\x87',
/* 0x00bd4 = "nist-sha256" */
    '\x05','\x86',
/* 0x00bd6 = "21" */
    '2','1',
/* 0x00bd8 = "V2" */
    'V','2',
/* 0x00bda = "nist-algorithms" */
    '\x05','\x1f',
/* 0x00bdc = "nist-sha224" */
    '\x05','\x85',
};
AssertCompile(sizeof(g_achStrTabOidDbStrTab) == 0xbde);

static const RTBLDPROGSTRREF g_aCompDictOidDbStrTab[256] = 
{
    /*[  0]=*/ { 0x000000, 0x00 }, // unused, because zero terminator
    /*[  1]=*/ { 0x000b6c, 0x03 }, //    225 - Ms-
    /*[  2]=*/ { 0x0008e7, 0x06 }, //    174 - pkcs9-
    /*[  3]=*/ { 0x000b78, 0x03 }, //    165 - id-
    /*[  4]=*/ { 0x000593, 0x09 }, //    162 - verisign-
    /*[  5]=*/ { 0x0009d8, 0x05 }, //    155 - nist-
    /*[  6]=*/ { 0x000501, 0x0a }, //    150 - Encryption
    /*[  7]=*/ { 0x0005e4, 0x09 }, //    108 - netscape-
    /*[  8]=*/ { 0x0007a2, 0x07 }, //     91 - policy-
    /*[  9]=*/ { 0x00081b, 0x06 }, //     90 - pkcs1-
    /*[ 10]=*/ { 0x0009e7, 0x05 }, //     80 - WithR
    /*[ 11]=*/ { 0x000971, 0x05 }, //     75 - with-
    /*[ 12]=*/ { 0x000232, 0x07 }, //     70 - Signing
    /*[ 13]=*/ { 0x000a80, 0x04 }, //     68 - pki-
    /*[ 14]=*/ { 0x00036f, 0x0b }, //     66 - Certificate
    /*[ 15]=*/ { 0x000bc5, 0x03 }, //     63 - ce-
    /*[ 16]=*/ { 0x000af3, 0x04 }, //     60 - RsaE
    /*[ 17]=*/ { 0x000b22, 0x03 }, //     57 - Spc
    /*[ 18]=*/ { 0x000ab4, 0x04 }, //     56 - Data
    /*[ 19]=*/ { 0x0009dd, 0x05 }, //     55 - sha3-
    /*[ 20]=*/ { 0x00050b, 0x0a }, //     50 - Deprecated
    /*[ 21]=*/ { 0x000aeb, 0x04 }, //     48 - Name
    /*[ 22]=*/ { 0x0009c9, 0x05 }, //     45 - ssig-
    /*[ 23]=*/ { 0x000b9e, 0x03 }, //     42 - kp-
    /*[ 24]=*/ { 0x000aef, 0x04 }, //     36 - Info
    /*[ 25]=*/ { 0x00092f, 0x06 }, //     36 - Crypto
    /*[ 26]=*/ { 0x000ac8, 0x04 }, //     36 - oiw-
    /*[ 27]=*/ { 0x000929, 0x06 }, //     36 - pkcs7-
    /*[ 28]=*/ { 0x00099e, 0x05 }, //     35 - x500-
    /*[ 29]=*/ { 0x00084b, 0x03 }, //     33 - Key
    /*[ 30]=*/ { 0x00030a, 0x04 }, //     32 - Cert
    /*[ 31]=*/ { 0x0004bb, 0x0a }, //     30 - algorithms
    /*[ 32]=*/ { 0x0007d3, 0x07 }, //     28 - Catalog
    /*[ 33]=*/ { 0x000895, 0x04 }, //     28 - dsa-
    /*[ 34]=*/ { 0x00058a, 0x04 }, //     24 - Auth
    /*[ 35]=*/ { 0x000917, 0x06 }, //     24 - apple-
    /*[ 36]=*/ { 0x0008cf, 0x06 }, //     24 - sha512
    /*[ 37]=*/ { 0x000456, 0x0b }, //     22 - Constraints
    /*[ 38]=*/ { 0x000786, 0x07 }, //     21 - rsassa-
    /*[ 39]=*/ { 0x0008f5, 0x04 }, //     20 - List
    /*[ 40]=*/ { 0x0009c1, 0x05 }, //     20 - SMime
    /*[ 41]=*/ { 0x000999, 0x05 }, //     20 - Usage
    /*[ 42]=*/ { 0x00055b, 0x0a }, //     20 - Attributes
    /*[ 43]=*/ { 0x000565, 0x0a }, //     20 - Identifier
    /*[ 44]=*/ { 0x000adb, 0x04 }, //     20 - vtn-
    /*[ 45]=*/ { 0x000000, 0x00 }, // '-'
    /*[ 46]=*/ { 0x000000, 0x00 }, // '.'
    /*[ 47]=*/ { 0x000000, 0x00 }, // '/'
    /*[ 48]=*/ { 0x000000, 0x00 }, // '0'
    /*[ 49]=*/ { 0x000000, 0x00 }, // '1'
    /*[ 50]=*/ { 0x000000, 0x00 }, // '2'
    /*[ 51]=*/ { 0x000000, 0x00 }, // '3'
    /*[ 52]=*/ { 0x000000, 0x00 }, // '4'
    /*[ 53]=*/ { 0x000000, 0x00 }, // '5'
    /*[ 54]=*/ { 0x000000, 0x00 }, // '6'
    /*[ 55]=*/ { 0x000000, 0x00 }, // '7'
    /*[ 56]=*/ { 0x000000, 0x00 }, // '8'
    /*[ 57]=*/ { 0x000000, 0x00 }, // '9'
    /*[ 58]=*/ { 0x00058a, 0x09 }, //     18 - Authority
    /*[ 59]=*/ { 0x000608, 0x09 }, //     18 - Encrypted
    /*[ 60]=*/ { 0x000ba4, 0x03 }, //     18 - cp-
    /*[ 61]=*/ { 0x000893, 0x06 }, //     18 - ecdsa-
    /*[ 62]=*/ { 0x0006ce, 0x08 }, //     16 - Recovery
    /*[ 63]=*/ { 0x000000, 0x00 }, // '?'
    /*[ 64]=*/ { 0x0006a6, 0x08 }, //     16 - security
    /*[ 65]=*/ { 0x000000, 0x00 }, // 'A'
    /*[ 66]=*/ { 0x000000, 0x00 }, // 'B'
    /*[ 67]=*/ { 0x000000, 0x00 }, // 'C'
    /*[ 68]=*/ { 0x000000, 0x00 }, // 'D'
    /*[ 69]=*/ { 0x000000, 0x00 }, // 'E'
    /*[ 70]=*/ { 0x000000, 0x00 }, // 'F'
    /*[ 71]=*/ { 0x000000, 0x00 }, // 'G'
    /*[ 72]=*/ { 0x000000, 0x00 }, // 'H'
    /*[ 73]=*/ { 0x000000, 0x00 }, // 'I'
    /*[ 74]=*/ { 0x000000, 0x00 }, // 'J'
    /*[ 75]=*/ { 0x000000, 0x00 }, // 'K'
    /*[ 76]=*/ { 0x000000, 0x00 }, // 'L'
    /*[ 77]=*/ { 0x000000, 0x00 }, // 'M'
    /*[ 78]=*/ { 0x000000, 0x00 }, // 'N'
    /*[ 79]=*/ { 0x000000, 0x00 }, // 'O'
    /*[ 80]=*/ { 0x000000, 0x00 }, // 'P'
    /*[ 81]=*/ { 0x000000, 0x00 }, // 'Q'
    /*[ 82]=*/ { 0x000000, 0x00 }, // 'R'
    /*[ 83]=*/ { 0x000000, 0x00 }, // 'S'
    /*[ 84]=*/ { 0x000000, 0x00 }, // 'T'
    /*[ 85]=*/ { 0x000000, 0x00 }, // 'U'
    /*[ 86]=*/ { 0x000000, 0x00 }, // 'V'
    /*[ 87]=*/ { 0x000000, 0x00 }, // 'W'
    /*[ 88]=*/ { 0x000b90, 0x03 }, //     15 - at-
    /*[ 89]=*/ { 0x000b63, 0x03 }, //     15 - ct-
    /*[ 90]=*/ { 0x000b66, 0x03 }, //     15 - url
    /*[ 91]=*/ { 0x0007b7, 0x07 }, //     14 - Subject
    /*[ 92]=*/ { 0x00077f, 0x07 }, //     14 - Trusted
    /*[ 93]=*/ { 0x0002ae, 0x0d }, //     13 - DistributionP
    /*[ 94]=*/ { 0x00039f, 0x03 }, //     12 - 224
    /*[ 95]=*/ { 0x0003ec, 0x03 }, //     12 - 256
    /*[ 96]=*/ { 0x000b17, 0x04 }, //     12 - AltN
    /*[ 97]=*/ { 0x000000, 0x00 }, // 'a'
    /*[ 98]=*/ { 0x000000, 0x00 }, // 'b'
    /*[ 99]=*/ { 0x000000, 0x00 }, // 'c'
    /*[100]=*/ { 0x000000, 0x00 }, // 'd'
    /*[101]=*/ { 0x000000, 0x00 }, // 'e'
    /*[102]=*/ { 0x000000, 0x00 }, // 'f'
    /*[103]=*/ { 0x000000, 0x00 }, // 'g'
    /*[104]=*/ { 0x000000, 0x00 }, // 'h'
    /*[105]=*/ { 0x000000, 0x00 }, // 'i'
    /*[106]=*/ { 0x000000, 0x00 }, // 'j'
    /*[107]=*/ { 0x000000, 0x00 }, // 'k'
    /*[108]=*/ { 0x000000, 0x00 }, // 'l'
    /*[109]=*/ { 0x000000, 0x00 }, // 'm'
    /*[110]=*/ { 0x000000, 0x00 }, // 'n'
    /*[111]=*/ { 0x000000, 0x00 }, // 'o'
    /*[112]=*/ { 0x000000, 0x00 }, // 'p'
    /*[113]=*/ { 0x000000, 0x00 }, // 'q'
    /*[114]=*/ { 0x000000, 0x00 }, // 'r'
    /*[115]=*/ { 0x000000, 0x00 }, // 's'
    /*[116]=*/ { 0x000000, 0x00 }, // 't'
    /*[117]=*/ { 0x000000, 0x00 }, // 'u'
    /*[118]=*/ { 0x000000, 0x00 }, // 'v'
    /*[119]=*/ { 0x000000, 0x00 }, // 'w'
    /*[120]=*/ { 0x000000, 0x00 }, // 'x'
    /*[121]=*/ { 0x000000, 0x00 }, // 'y'
    /*[122]=*/ { 0x000000, 0x00 }, // 'z'
    /*[123]=*/ { 0x0008f3, 0x06 }, //     12 - CAList
    /*[124]=*/ { 0x00082d, 0x06 }, //     12 - Points
    /*[125]=*/ { 0x00085d, 0x06 }, //     12 - Server
    /*[126]=*/ { 0x000869, 0x06 }, //     12 - Sha512
    /*[127]=*/ { 0x00091d, 0x06 }, //     12 - System
    /*[128]=*/ { 0x0002e0, 0x0c }, //     12 - Organization
    /*[129]=*/ { 0x000875, 0x06 }, //     12 - TrustL
    /*[130]=*/ { 0x000ab0, 0x04 }, //     12 - ext-
    /*[131]=*/ { 0x000b8a, 0x03 }, //     12 - qt-
    /*[132]=*/ { 0x000b6f, 0x03 }, //     12 - usa
    /*[133]=*/ { 0x000887, 0x06 }, //     12 - sha224
    /*[134]=*/ { 0x000923, 0x06 }, //     12 - sha256
    /*[135]=*/ { 0x0008b1, 0x06 }, //     12 - sha384
    /*[136]=*/ { 0x000414, 0x0b }, //     11 - revocation-
    /*[137]=*/ { 0x00093f, 0x05 }, //     10 - CodeS
    /*[138]=*/ { 0x0009a3, 0x05 }, //     10 - IPSec
    /*[139]=*/ { 0x0009bc, 0x05 }, //     10 - Image
    /*[140]=*/ { 0x0004b1, 0x0a }, //     10 - CriterialI
    /*[141]=*/ { 0x0004c5, 0x0a }, //     10 - EnvelopedD
    /*[142]=*/ { 0x000475, 0x0a }, //     10 - ExtensionR
    /*[143]=*/ { 0x000a28, 0x05 }, //     10 - cert-
    /*[144]=*/ { 0x000b34, 0x03 }, //      9 - Crl
    /*[145]=*/ { 0x00067d, 0x09 }, //      9 - Policies-
    /*[146]=*/ { 0x000623, 0x09 }, //      9 - Signature
    /*[147]=*/ { 0x000b9b, 0x03 }, //      9 - aa-
    /*[148]=*/ { 0x000647, 0x09 }, //      9 - attribute
    /*[149]=*/ { 0x000b8d, 0x03 }, //      9 - v1-
    /*[150]=*/ { 0x0006f6, 0x08 }, //      8 - CounterS
    /*[151]=*/ { 0x000a90, 0x04 }, //      8 - DevI
    /*[152]=*/ { 0x000ab8, 0x04 }, //      8 - File
    /*[153]=*/ { 0x000a7c, 0x04 }, //      8 - Md4W
    /*[154]=*/ { 0x000ae3, 0x04 }, //      8 - Md5W
    /*[155]=*/ { 0x000acc, 0x04 }, //      8 - Page
    /*[156]=*/ { 0x000ad3, 0x04 }, //      8 - Sha1
    /*[157]=*/ { 0x0001cc, 0x04 }, //      8 - Time
    /*[158]=*/ { 0x000268, 0x04 }, //      8 - Type
    /*[159]=*/ { 0x000706, 0x08 }, //      8 - PrivateK
    /*[160]=*/ { 0x000ac4, 0x04 }, //      8 - cis-
    /*[161]=*/ { 0x000b07, 0x04 }, //      8 - eku-
    /*[162]=*/ { 0x00071d, 0x07 }, //      7 - Address
    /*[163]=*/ { 0x000747, 0x07 }, //      7 - ClientA
    /*[164]=*/ { 0x000739, 0x07 }, //      7 - EAPOver
    /*[165]=*/ { 0x000716, 0x07 }, //      7 - EnrollC
    /*[166]=*/ { 0x000740, 0x07 }, //      7 - HashesV
    /*[167]=*/ { 0x000732, 0x07 }, //      7 - IssuerA
    /*[168]=*/ { 0x000755, 0x07 }, //      7 - PKCS12-
    /*[169]=*/ { 0x00075c, 0x07 }, //      7 - Request
    /*[170]=*/ { 0x00074e, 0x07 }, //      7 - thawte-
    /*[171]=*/ { 0x0003f7, 0x03 }, //      6 - 384
    /*[172]=*/ { 0x00086c, 0x03 }, //      6 - 512
    /*[173]=*/ { 0x000833, 0x06 }, //      6 - GatedC
    /*[174]=*/ { 0x000b4e, 0x03 }, //      6 - Id-
    /*[175]=*/ { 0x0008a5, 0x06 }, //      6 - Member
    /*[176]=*/ { 0x000b4c, 0x03 }, //      6 - PeI
    /*[177]=*/ { 0x00087b, 0x06 }, //      6 - Policy
    /*[178]=*/ { 0x000809, 0x06 }, //      6 - Signer
    /*[179]=*/ { 0x00090b, 0x06 }, //      6 - TokenI
    /*[180]=*/ { 0x000b54, 0x03 }, //      6 - cs-
    /*[181]=*/ { 0x000b72, 0x03 }, //      6 - ms-
    /*[182]=*/ { 0x0008b7, 0x06 }, //      6 - server
    /*[183]=*/ { 0x0008ff, 0x06 }, //      6 - signed
    /*[184]=*/ { 0x000a32, 0x05 }, //      5 - HashI
    /*[185]=*/ { 0x000a00, 0x05 }, //      5 - JavaC
    /*[186]=*/ { 0x000949, 0x05 }, //      5 - LinkT
    /*[187]=*/ { 0x000a23, 0x05 }, //      5 - LogoT
    /*[188]=*/ { 0x0009e2, 0x05 }, //      5 - Stamp
    /*[189]=*/ { 0x0009f6, 0x05 }, //      5 - WhqlC
    /*[190]=*/ { 0x000976, 0x05 }, //      5 - pkix-
    /*[191]=*/ { 0x000aff, 0x04 }, //      4 - Md2W
    /*[192]=*/ { 0x000afb, 0x04 }, //      4 - Next
    /*[193]=*/ { 0x000232, 0x04 }, //      4 - Sign
    /*[194]=*/ { 0x000ac0, 0x04 }, //      4 - User
    /*[195]=*/ { 0x000abc, 0x04 }, //      4 - dod-
    /*[196]=*/ { 0x000a98, 0x04 }, //      4 - dot-
    /*[197]=*/ { 0x000bb3, 0x03 }, //      3 - ??-
    /*[198]=*/ { 0x0007d3, 0x03 }, //      3 - Cat
    /*[199]=*/ { 0x000b51, 0x03 }, //      3 - Ctl
    /*[200]=*/ { 0x000b40, 0x03 }, //      3 - Drm
    /*[201]=*/ { 0x0000c5, 0x03 }, //      3 - Ext
    /*[202]=*/ { 0x000b37, 0x03 }, //      3 - Srv
    /*[203]=*/ { 0x000b46, 0x03 }, //      3 - ca-
    /*[204]=*/ { 0x000bd8, 0x02 }, //      2 - V2
    /*[205]=*/ { 0x000a60, 0x04 }, //      0 - .2.4
    /*[206]=*/ { 0x000b43, 0x03 }, //      0 - 2.1
    /*[207]=*/ { 0x000bd6, 0x02 }, //      0 - 21
    /*[208]=*/ { 0x000b7e, 0x03 }, //      0 - 3.2
    /*[209]=*/ { 0x000ad0, 0x04 }, //      0 - ACPS
    /*[210]=*/ { 0x000b99, 0x03 }, //      0 - Aka
    /*[211]=*/ { 0x000aa4, 0x04 }, //      0 - Algs
    /*[212]=*/ { 0x000b5d, 0x03 }, //      0 - And
    /*[213]=*/ { 0x000a48, 0x04 }, //      0 - Auto
    /*[214]=*/ { 0x000aa0, 0x04 }, //      0 - Base
    /*[215]=*/ { 0x000b69, 0x03 }, //      0 - CAs
    /*[216]=*/ { 0x000ad1, 0x03 }, //      0 - CPS
    /*[217]=*/ { 0x0001f7, 0x02 }, //      0 - Ca
    /*[218]=*/ { 0x000b3d, 0x03 }, //      0 - Cab
    /*[219]=*/ { 0x000845, 0x06 }, //      0 - Access
    /*[220]=*/ { 0x000815, 0x06 }, //      0 - Agency
    /*[221]=*/ { 0x000a2d, 0x05 }, //      0 - Basic
    /*[222]=*/ { 0x000a40, 0x04 }, //      0 - Capi
    /*[223]=*/ { 0x00026f, 0x03 }, //      0 - Com
    /*[224]=*/ { 0x000935, 0x05 }, //      0 - Class
    /*[225]=*/ { 0x000a44, 0x04 }, //      0 - Corp
    /*[226]=*/ { 0x000851, 0x06 }, //      0 - Common
    /*[227]=*/ { 0x0009c6, 0x05 }, //      0 - Cross
    /*[228]=*/ { 0x000aac, 0x04 }, //      0 - DVCS
    /*[229]=*/ { 0x0002ae, 0x04 }, //      0 - Dist
    /*[230]=*/ { 0x000baa, 0x03 }, //      0 - EKU
    /*[231]=*/ { 0x000bad, 0x03 }, //      0 - End
    /*[232]=*/ { 0x000910, 0x02 }, //      0 - ID
    /*[233]=*/ { 0x00063e, 0x09 }, //      0 - AAService
    /*[234]=*/ { 0x0005db, 0x09 }, //      0 - ACUNotice
    /*[235]=*/ { 0x0006ae, 0x08 }, //      0 - Certtype
    /*[236]=*/ { 0x000778, 0x07 }, //      0 - Content
    /*[237]=*/ { 0x00072b, 0x07 }, //      0 - Context
    /*[238]=*/ { 0x000794, 0x07 }, //      0 - Country
    /*[239]=*/ { 0x000911, 0x06 }, //      0 - Digest
    /*[240]=*/ { 0x0009d3, 0x05 }, //      0 - Dummy
    /*[241]=*/ { 0x000a37, 0x05 }, //      0 - EMail
    /*[242]=*/ { 0x0009ad, 0x05 }, //      0 - Email
    /*[243]=*/ { 0x000881, 0x06 }, //      0 - Entity
    /*[244]=*/ { 0x00096c, 0x05 }, //      0 - Fonts
    /*[245]=*/ { 0x000a84, 0x04 }, //      0 - Home
    /*[246]=*/ { 0x0005cc, 0x03 }, //      0 - Iss
    /*[247]=*/ { 0x000bcb, 0x03 }, //      0 - LAN
    /*[248]=*/ { 0x000bbf, 0x02 }, //      0 - Nt
    /*[249]=*/ { 0x000bbf, 0x03 }, //      0 - Nt5
    /*[250]=*/ { 0x000b96, 0x03 }, //      0 - Oem
    /*[251]=*/ { 0x0002e0, 0x02 }, //      0 - Or
    /*[252]=*/ { 0x000944, 0x05 }, //      0 - Index
    /*[253]=*/ { 0x00089f, 0x06 }, //      0 - Kernel
    /*[254]=*/ { 0x00084b, 0x06 }, //      0 - Keyset
    /*[255]=*/ { 0x00046c, 0x05 }, //      0 - Local
};

static const RTBLDPROGSTRTAB g_OidDbStrTab = 
{
    /*.pchStrTab  = */ &g_achStrTabOidDbStrTab[0],
    /*.cchStrTab  = */ sizeof(g_achStrTabOidDbStrTab),
    /*.cCompDict  = */ 256,
    /*.paCompDict = */ &g_aCompDictOidDbStrTab[0]
};

#if defined(RT_ARCH_AMD64) || defined(RT_ARCH_X86)
# pragma pack(2)
#endif
typedef struct RTOIDENTRYSMALL
{
    uint32_t    uKey        : 6;
    uint32_t    cchString   : 6;
    uint32_t    fBigTable   : 1;
    uint32_t    cChildren   : 7;
    uint32_t    idxChildren : 12;
    uint16_t    offString;
} RTOIDENTRYSMALL;
#if defined(RT_ARCH_AMD64) || defined(RT_ARCH_X86)
# pragma pack()
AssertCompileSize(RTOIDENTRYSMALL, 6);
#endif
typedef RTOIDENTRYSMALL const *PCRTOIDENTRYSMALL;

static const RTOIDENTRYSMALL g_aSmallOidTable[] = 
{
    {  1,  0, 0,  2,    2, 000000 }, /* 0.1 */
    {  2, 15, 0,  3,  178, 0x019d }, /* 0.2 = "joint-iso/itu-t" */
    {  2,  0, 1,  1,    0, 000000 }, /* 0.1.2 */
    {  3,  0, 0,  2,   64, 000000 }, /* 0.1.3 */
    {  1,  4, 0,  3,    5, 0x081b }, /* 0.1.2.840.113549.1 = "pkcs" */
    {  1,  5, 0, 12,    8, 0x081b }, /* 0.1.2.840.113549.1.1 = "pkcs1" */
    {  7,  5, 0,  6,   20, 0x0929 }, /* 0.1.2.840.113549.1.7 = "pkcs7" */
    {  9,  5, 0, 14,   26, 0x08e7 }, /* 0.1.2.840.113549.1.9 = "pkcs9" */
    {  1, 11, 0,  0,    0, 0x03b1 }, /* 0.1.2.840.113549.1.1.1 = "pkcs1-RsaEncryption" */
    {  2, 15, 0,  0,    0, 0x018e }, /* 0.1.2.840.113549.1.1.2 = "pkcs1-Md2WithRsaEncryption" */
    {  3, 15, 0,  0,    0, 0x017f }, /* 0.1.2.840.113549.1.1.3 = "pkcs1-Md4WithRsaEncryption" */
    {  4, 15, 0,  0,    0, 0x0161 }, /* 0.1.2.840.113549.1.1.4 = "pkcs1-Md5WithRsaEncryption" */
    {  5,  6, 0,  0,    0, 0x0857 }, /* 0.1.2.840.113549.1.1.5 = "pkcs1-Sha1WithRsaEncryption" */
    { 10,  7, 0,  0,    0, 0x07a9 }, /* 0.1.2.840.113549.1.1.10 = "pkcs1-RsaPss" */
    { 11, 11, 0,  0,    0, 0x03e8 }, /* 0.1.2.840.113549.1.1.11 = "pkcs1-Sha256WithRsaEncryption" */
    { 12, 11, 0,  0,    0, 0x03f3 }, /* 0.1.2.840.113549.1.1.12 = "pkcs1-Sha384WithRsaEncryption" */
    { 13,  6, 0,  0,    0, 0x07fd }, /* 0.1.2.840.113549.1.1.13 = "pkcs1-Sha512WithRsaEncryption" */
    { 14, 11, 0,  0,    0, 0x039b }, /* 0.1.2.840.113549.1.1.14 = "pkcs1-Sha224WithRsaEncryption" */
    { 15,  8, 0,  0,    0, 0x06be }, /* 0.1.2.840.113549.1.1.15 = "pkcs1-Sha512-224WithRsaEncryption" */
    { 16,  8, 0,  0,    0, 0x06de }, /* 0.1.2.840.113549.1.1.16 = "pkcs1-Sha512-256WithRsaEncryption" */
    {  1,  5, 0,  0,    0, 0x0a05 }, /* 0.1.2.840.113549.1.7.1 = "pkcs7-data" */
    {  2,  3, 0,  0,    0, 0x0b25 }, /* 0.1.2.840.113549.1.7.2 = "pkcs7-signedData" */
    {  3, 11, 0,  0,    0, 0x03dd }, /* 0.1.2.840.113549.1.7.3 = "pkcs7-envelopedData" */
    {  4,  7, 0,  0,    0, 0x076a }, /* 0.1.2.840.113549.1.7.4 = "pkcs7-signedAndEnvelopedData" */
    {  5, 10, 0,  0,    0, 0x0461 }, /* 0.1.2.840.113549.1.7.5 = "pkcs7-digestedData" */
    {  6, 11, 0,  0,    0, 0x03c7 }, /* 0.1.2.840.113549.1.7.6 = "pkcs7-encryptedData" */
    {  1,  3, 0,  0,    0, 0x0b87 }, /* 0.1.2.840.113549.1.9.1 = "pkcs9-EMailAddress" */
    {  2, 11, 0,  0,    0, 0x03fe }, /* 0.1.2.840.113549.1.9.2 = "pkcs9-UntrustedName" */
    {  3,  3, 0,  0,    0, 0x0bc8 }, /* 0.1.2.840.113549.1.9.3 = "pkcs9-ContentType" */
    {  4,  9, 0,  0,    0, 0x05c0 }, /* 0.1.2.840.113549.1.9.4 = "pkcs9-MessageDigest" */
    {  5,  3, 0,  0,    0, 0x0b93 }, /* 0.1.2.840.113549.1.9.5 = "pkcs9-SigningTime" */
    {  6, 10, 0,  0,    0, 0x0489 }, /* 0.1.2.840.113549.1.9.6 = "pkcs9-CounterSignature" */
    {  7, 18, 0,  0,    0, 0x00aa }, /* 0.1.2.840.113549.1.9.7 = "pkcs9-challengePassword" */
    {  8, 14, 0,  0,    0, 0x0211 }, /* 0.1.2.840.113549.1.9.8 = "pkcs9-UnstructuredAddress" */
    {  9, 11, 0,  0,    0, 0x03a6 }, /* 0.1.2.840.113549.1.9.9 = "pkcs9-ExtendedCertificateAttributes" */
    { 13, 13, 0,  0,    0, 0x02bb }, /* 0.1.2.840.113549.1.9.13 = "pkcs9-SigningDescription" */
    { 14,  8, 0,  0,    0, 0x0696 }, /* 0.1.2.840.113549.1.9.14 = "pkcs9-ExtensionRequest" */
    { 15, 14, 0,  0,    0, 0x01f5 }, /* 0.1.2.840.113549.1.9.15 = "pkcs9-SMimeCapabilities" */
    { 16,  2, 0,  2,   40, 0x01f5 }, /* 0.1.2.840.113549.1.9.16 = "pkcs9-SMime" */
    { 25,  5, 0,  5,   50, 0x09b7 }, /* 0.1.2.840.113549.1.9.25 = "pkcs9-SMime-at" */
    {  1,  5, 0,  5,   42, 0x095d }, /* 0.1.2.840.113549.1.9.16.1 = "pkcs9-SMime-ct" */
    {  2,  6, 0,  3,   47, 0x080f }, /* 0.1.2.840.113549.1.9.16.2 = "pkcs9-SMime-id-aa" */
    {  2,  4, 0,  0,    0, 0x0a50 }, /* 0.1.2.840.113549.1.9.16.1.2 = "pkcs9-ct-AuthData" */
    {  4, 15, 0,  0,    0, 0x01ca }, /* 0.1.2.840.113549.1.9.16.1.4 = "pkcs9-ct-TimestampTokenInfo" */
    {  9, 13, 0,  0,    0, 0x0294 }, /* 0.1.2.840.113549.1.9.16.1.9 = "pkcs9-ct-CompressedData" */
    { 23,  7, 0,  0,    0, 0x0763 }, /* 0.1.2.840.113549.1.9.16.1.23 = "pkcs9-ct-AuthEnvelopedData" */
    { 31, 14, 0,  0,    0, 0x0203 }, /* 0.1.2.840.113549.1.9.16.1.31 = "pkcs9-ct-TimestampedData" */
    { 12,  5, 0,  0,    0, 0x09ec }, /* 0.1.2.840.113549.1.9.16.2.12 = "pkcs9-id-aa-SigningCertificate" */
    { 14,  4, 0,  0,    0, 0x0b13 }, /* 0.1.2.840.113549.1.9.16.2.14 = "pkcs9-id-aa-Attributes" */
    { 47, 12, 0,  0,    0, 0x034c }, /* 0.1.2.840.113549.1.9.16.2.47 = "pkcs9-id-aa-signingCertificateV2" */
    {  1, 13, 0,  0,    0, 0x021f }, /* 0.1.2.840.113549.1.9.25.1 = "pkcs9-at-Pkcs15Token" */
    {  2,  7, 0,  0,    0, 0x07da }, /* 0.1.2.840.113549.1.9.25.2 = "pkcs9-at-EncryptedPrivateKeyInfo" */
    {  3, 13, 0,  0,    0, 0x027a }, /* 0.1.2.840.113549.1.9.25.3 = "pkcs9-at-RandomNonce" */
    {  4, 16, 0,  0,    0, 0x0101 }, /* 0.1.2.840.113549.1.9.25.4 = "pkcs9-at-SequenceNumber" */
    {  5, 10, 0,  0,    0, 0x0529 }, /* 0.1.2.840.113549.1.9.25.5 = "pkcs9-at-Pkcs7PDU" */
    {  4,  0, 0,  1,   58, 000000 }, /* 0.1.2.840.113635.100.4 */
    {  5,  0, 0,  1,   59, 000000 }, /* 0.1.2.840.113635.100.5 */
    {  6,  0, 0,  1,   60, 000000 }, /* 0.1.2.840.113635.100.6 */
    { 13, 10, 0,  0,    0, 0x0515 }, /* 0.1.2.840.113635.100.4.13 = "apple-eku-packageSign" */
    {  1,  8, 0,  0,    0, 0x0686 }, /* 0.1.2.840.113635.100.5.1 = "apple-cert-policy" */
    {  1,  0, 0,  3,   61, 000000 }, /* 0.1.2.840.113635.100.6.1 */
    { 13, 17, 0,  0,    0, 0x00ce }, /* 0.1.2.840.113635.100.6.1.13 = "apple-cs-ext-DevId-Application" */
    { 14, 15, 0,  0,    0, 0x01bb }, /* 0.1.2.840.113635.100.6.1.14 = "apple-cs-ext-DevId-Installer" */
    { 18,  8, 0,  0,    0, 0x06fe }, /* 0.1.2.840.113635.100.6.1.18 = "apple-cs-ext-DevId-KernelExt" */
    {  6,  3, 0,  1,   66, 0x0abc }, /* 0.1.3.6 = "dod" */
    { 14,  0, 0,  1,  168, 000000 }, /* 0.1.3.14 */
    {  1,  9, 0,  2,   67, 0x0662 }, /* 0.1.3.6.1 = "dod-Internet" */
    {  4,  0, 0,  1,   69, 000000 }, /* 0.1.3.6.1.4 */
    {  5,  1, 0,  1,  143, 0x0054 }, /* 0.1.3.6.1.5 = "security" */
    {  1,  0, 1,  1,    4, 000000 }, /* 0.1.3.6.1.4.1 */
    {  1,  4, 0, 18,   74, 0x0b0b }, /* 0.1.3.6.1.4.1.311.2.1 = "ms-spc" */
    {  2,  4, 0,  3,   92, 0x0a5c }, /* 0.1.3.6.1.4.1.311.2.2 = "Ms-Ctl-CAs" */
    {  3,  0, 0,  2,   95, 000000 }, /* 0.1.3.6.1.4.1.311.2.3 */
    {  4,  3, 0,  1,   97, 0x0b31 }, /* 0.1.3.6.1.4.1.311.2.4 = "Ms-??-.2.4" */
    {  1,  3, 0,  0,    0, 0x0b2e }, /* 0.1.3.6.1.4.1.311.2.1.1 = "Ms-??-2.1" */
    {  4, 12, 0,  0,    0, 0x02ec }, /* 0.1.3.6.1.4.1.311.2.1.4 = "Ms-SpcIndirectDataContext" */
    { 10,  4, 0,  0,    0, 0x0a68 }, /* 0.1.3.6.1.4.1.311.2.1.10 = "Ms-SpcAgencyInfo" */
    { 11, 12, 0,  0,    0, 0x0340 }, /* 0.1.3.6.1.4.1.311.2.1.11 = "Ms-SpcStatementType" */
    { 12,  7, 0,  0,    0, 0x07be }, /* 0.1.3.6.1.4.1.311.2.1.12 = "Ms-SpcOpusInfo" */
    { 14, 15, 0,  0,    0, 0x01ac }, /* 0.1.3.6.1.4.1.311.2.1.14 = "Ms-CertReqExtensions" */
    { 15,  8, 0,  0,    0, 0x06d6 }, /* 0.1.3.6.1.4.1.311.2.1.15 = "Ms-SpcPeImageData" */
    { 18,  7, 0,  0,    0, 0x079b }, /* 0.1.3.6.1.4.1.311.2.1.18 = "Ms-SpcRawFileData" */
    { 19, 20, 0,  0,    0, 0x005e }, /* 0.1.3.6.1.4.1.311.2.1.19 = "Ms-SpcStructuredStorageData" */
    { 20, 13, 0,  0,    0, 0x0260 }, /* 0.1.3.6.1.4.1.311.2.1.20 = "Ms-SpcJavaClassDataType1" */
    { 21, 19, 0,  0,    0, 0x0072 }, /* 0.1.3.6.1.4.1.311.2.1.21 = "Ms-SpcIndividualCodeSigning" */
    { 22, 13, 0,  0,    0, 0x026d }, /* 0.1.3.6.1.4.1.311.2.1.22 = "Ms-SpcCommericalSigning" */
    { 25, 12, 0,  0,    0, 0x0358 }, /* 0.1.3.6.1.4.1.311.2.1.25 = "Ms-SpcLinkType2-Aka-CabData" */
    { 26, 13, 0,  0,    0, 0x0239 }, /* 0.1.3.6.1.4.1.311.2.1.26 = "Ms-SpcMinimalCriterialInfo" */
    { 27, 14, 0,  0,    0, 0x01d9 }, /* 0.1.3.6.1.4.1.311.2.1.27 = "Ms-SpcFinacialCriterialInfo" */
    { 28,  7, 0,  0,    0, 0x0771 }, /* 0.1.3.6.1.4.1.311.2.1.28 = "Ms-SpcLinkType3" */
    { 29,  6, 0,  0,    0, 0x0863 }, /* 0.1.3.6.1.4.1.311.2.1.29 = "Ms-SpcHashInfo" */
    { 30,  6, 0,  0,    0, 0x08ab }, /* 0.1.3.6.1.4.1.311.2.1.30 = "Ms-SpcSipInfo" */
    {  1, 10, 0,  0,    0, 0x0493 }, /* 0.1.3.6.1.4.1.311.2.2.1 = "Ms-TrustedCodeSigningCAList" */
    {  2,  7, 0,  0,    0, 0x07e8 }, /* 0.1.3.6.1.4.1.311.2.2.2 = "Ms-TrustedClientAuthCAList" */
    {  3,  5, 0,  0,    0, 0x0967 }, /* 0.1.3.6.1.4.1.311.2.2.3 = "Ms-TrustedServerAuthCAList" */
    {  1, 10, 0,  0,    0, 0x053d }, /* 0.1.3.6.1.4.1.311.2.3.1 = "Ms-SpcPeImagePageHashesV1" */
    {  2, 10, 0,  0,    0, 0x0547 }, /* 0.1.3.6.1.4.1.311.2.3.2 = "Ms-SpcPeImagePageHashesV2" */
    {  1,  9, 0,  0,    0, 0x05ae }, /* 0.1.3.6.1.4.1.311.2.4.1 = "Ms-SpcNestedSignature" */
    {  2,  0, 0,  1,  100, 000000 }, /* 0.1.3.6.1.4.1.311.3.2 */
    {  3,  0, 0,  2,  101, 000000 }, /* 0.1.3.6.1.4.1.311.3.3 */
    {  1,  5, 0,  0,    0, 0x09ce }, /* 0.1.3.6.1.4.1.311.3.2.1 = "Ms-SpcTimeStampRequest" */
    {  1,  5, 0,  0,    0, 0x098a }, /* 0.1.3.6.1.4.1.311.3.3.1 = "Ms-CounterSign" */
    {  2,  4, 0,  0,    0, 0x0ad7 }, /* 0.1.3.6.1.4.1.311.3.3.2 = "Ms-?-3.2" */
    {  1,  6, 0,  1,  108, 0x0899 }, /* 0.1.3.6.1.4.1.311.10.1 = "Ms-CertTrustList" */
    {  2, 16, 0,  0,    0, 0x0111 }, /* 0.1.3.6.1.4.1.311.10.2 = "Ms-NextUpdateLocation" */
    {  3,  2, 0, 13,  109, 0x0bce }, /* 0.1.3.6.1.4.1.311.10.3 = "Ms-EKU" */
    {  5,  0, 0,  2,  124, 000000 }, /* 0.1.3.6.1.4.1.311.10.5 */
    {  9,  0, 0,  1,  126, 000000 }, /* 0.1.3.6.1.4.1.311.10.9 */
    {  1, 12, 0,  0,    0, 0x02c8 }, /* 0.1.3.6.1.4.1.311.10.1.1 = "Ms-SortedCertTrustList" */
    {  1,  8, 0,  0,    0, 0x06ee }, /* 0.1.3.6.1.4.1.311.10.3.1 = "Ms-kp-CertTrustListSigning" */
    {  2,  5, 0,  0,    0, 0x09a8 }, /* 0.1.3.6.1.4.1.311.10.3.2 = "Ms-kp-TimeStampSigning" */
    {  3,  8, 0,  1,  122, 0x068e }, /* 0.1.3.6.1.4.1.311.10.3.3 = "Ms-ServerGatedCrypto" */
    {  4,  4, 0,  1,  123, 0x088d }, /* 0.1.3.6.1.4.1.311.10.3.4 = "Ms-EncryptedFileSystem" */
    {  5,  7, 0,  0,    0, 0x0724 }, /* 0.1.3.6.1.4.1.311.10.3.5 = "Ms-WhqlCrypto" */
    {  6,  3, 0,  0,    0, 0x0b3a }, /* 0.1.3.6.1.4.1.311.10.3.6 = "Ms-Nt5Crypto" */
    {  7,  8, 0,  0,    0, 0x06e6 }, /* 0.1.3.6.1.4.1.311.10.3.7 = "Ms-OemWhqlCrypto" */
    {  8, 11, 0,  0,    0, 0x0385 }, /* 0.1.3.6.1.4.1.311.10.3.8 = "Ms-EmbeddedNtCrypto" */
    {  9,  7, 0,  0,    0, 0x078d }, /* 0.1.3.6.1.4.1.311.10.3.9 = "Ms-RootListSigner" */
    { 10, 23, 0,  0,    0, 0x0032 }, /* 0.1.3.6.1.4.1.311.10.3.10 = "Ms-QualifiedSubordination" */
    { 11,  3, 0,  0,    0, 0x0b2b }, /* 0.1.3.6.1.4.1.311.10.3.11 = "Ms-KeyRecovery" */
    { 12, 10, 0,  0,    0, 0x049d }, /* 0.1.3.6.1.4.1.311.10.3.12 = "Ms-DocumentSigning" */
    { 13, 10, 0,  0,    0, 0x051f }, /* 0.1.3.6.1.4.1.311.10.3.13 = "Ms-LifetimeSigning" */
    {  1, 11, 0,  0,    0, 0x0390 }, /* 0.1.3.6.1.4.1.311.10.3.3.1 = "Ms-Serialized" */
    {  1,  6, 0,  0,    0, 0x088d }, /* 0.1.3.6.1.4.1.311.10.3.4.1 = "Ms-EncryptedFileSystem-Recovery" */
    {  1,  2, 0,  0,    0, 0x0085 }, /* 0.1.3.6.1.4.1.311.10.5.1 = "Ms-Drm" */
    {  2, 19, 0,  0,    0, 0x0085 }, /* 0.1.3.6.1.4.1.311.10.5.2 = "Ms-DrmIndividualization" */
    {  1,  5, 0,  0,    0, 0x09f1 }, /* 0.1.3.6.1.4.1.311.10.9.1 = "Ms-CrossCertDistPoints" */
    {  1,  5, 0,  2,  129, 0x0953 }, /* 0.1.3.6.1.4.1.311.12.1 = "Ms-Catalog-dot-1" */
    {  2,  5, 0,  2,  131, 0x094e }, /* 0.1.3.6.1.4.1.311.12.2 = "Ms-Catalog-dot-2" */
    {  1,  3, 0,  0,    0, 0x0a8c }, /* 0.1.3.6.1.4.1.311.12.1.1 = "Ms-CatalogList" */
    {  2,  4, 0,  0,    0, 0x0a8c }, /* 0.1.3.6.1.4.1.311.12.1.2 = "Ms-CatalogListMember" */
    {  1,  8, 0,  0,    0, 0x06b6 }, /* 0.1.3.6.1.4.1.311.12.2.1 = "Ms-CatNameValue" */
    {  2,  4, 0,  0,    0, 0x0a4c }, /* 0.1.3.6.1.4.1.311.12.2.2 = "Ms-CatMemberInfo" */
    {  1, 11, 0,  0,    0, 0x03bc }, /* 0.1.3.6.1.4.1.311.17.1 = "Ms-PKCS12-LocalMachineKeyset" */
    {  1,  6, 0,  0,    0, 0x08bd }, /* 0.1.3.6.1.4.1.311.20.1 = "Ms-AutoEnrollCtlUsage" */
    {  2, 18, 0,  0,    0, 0x00bc }, /* 0.1.3.6.1.4.1.311.20.2 = "Ms-EnrollCerttypeExtension" */
    {  1,  9, 0,  0,    0, 0x0578 }, /* 0.1.3.6.1.4.1.311.21.1 = "Ms-CaKeyCertIndexPair" */
    {  2, 16, 0,  0,    0, 0x0131 }, /* 0.1.3.6.1.4.1.311.21.2 = "Ms-CertSrvPreviousCertHash" */
    {  3, 10, 0,  0,    0, 0x04d9 }, /* 0.1.3.6.1.4.1.311.21.3 = "Ms-CrlVirtualBase" */
    {  4, 10, 0,  0,    0, 0x0551 }, /* 0.1.3.6.1.4.1.311.21.4 = "Ms-CrlNextPublish" */
    {  6,  3, 0,  0,    0, 0x0b2b }, /* 0.1.3.6.1.4.1.311.21.6 = "Ms-KeyRecovery" */
    {  7, 10, 0,  0,    0, 0x047f }, /* 0.1.3.6.1.4.1.311.21.7 = "Ms-CertificateTemplate" */
    {  9,  3, 0,  0,    0, 0x0ba1 }, /* 0.1.3.6.1.4.1.311.21.9 = "Ms-DummySigner" */
    {  5, 12, 0,  1,  144, 0x031c }, /* 0.1.3.6.1.5.5 = "security-Mechanisms" */
    {  7, 25, 0,  3,  145, 000000 }, /* 0.1.3.6.1.5.5.7 = "public-key-infrastructure" */
    {  1,  0, 0,  2,  148, 000000 }, /* 0.1.3.6.1.5.5.7.1 */
    {  2,  0, 0,  5,  150, 000000 }, /* 0.1.3.6.1.5.5.7.2 */
    {  3,  0, 0, 13,  155, 000000 }, /* 0.1.3.6.1.5.5.7.3 */
    {  1,  4, 0,  0,    0, 0x0a9c }, /* 0.1.3.6.1.5.5.7.1.1 = "pkix-AuthorityInfoAccess" */
    { 12,  5, 0,  0,    0, 0x0985 }, /* 0.1.3.6.1.5.5.7.1.12 = "pkix-LogoType" */
    {  1,  3, 0,  0,    0, 0x0bb9 }, /* 0.1.3.6.1.5.5.7.2.1 = "id-qt-CPS" */
    {  2,  9, 0,  0,    0, 0x05d2 }, /* 0.1.3.6.1.5.5.7.2.2 = "id-qt-UNotice" */
    {  3, 12, 0,  0,    0, 0x02f8 }, /* 0.1.3.6.1.5.5.7.2.3 = "id-qt-TextNotice" */
    {  4,  3, 0,  0,    0, 0x0bbc }, /* 0.1.3.6.1.5.5.7.2.4 = "id-qt-ACPS" */
    {  5,  3, 0,  0,    0, 0x0bc2 }, /* 0.1.3.6.1.5.5.7.2.5 = "id-qt-ACUNotice" */
    {  1,  4, 0,  0,    0, 0x0b03 }, /* 0.1.3.6.1.5.5.7.3.1 = "id-kp-ServerAuth" */
    {  2,  6, 0,  0,    0, 0x0827 }, /* 0.1.3.6.1.5.5.7.3.2 = "id-kp-ClientAuth" */
    {  3,  9, 0,  0,    0, 0x061a }, /* 0.1.3.6.1.5.5.7.3.3 = "id-kp-CodeSigning" */
    {  4, 13, 0,  0,    0, 0x0253 }, /* 0.1.3.6.1.5.5.7.3.4 = "id-kp-EmailProtection" */
    {  5,  5, 0,  0,    0, 0x09b2 }, /* 0.1.3.6.1.5.5.7.3.5 = "id-kp-IPSecEndSystem" */
    {  6,  9, 0,  0,    0, 0x066b }, /* 0.1.3.6.1.5.5.7.3.6 = "id-kp-IPSecTunnel" */
    {  7,  4, 0,  0,    0, 0x0a94 }, /* 0.1.3.6.1.5.5.7.3.7 = "id-kp-IPSecUser" */
    {  8, 14, 0,  0,    0, 0x01e7 }, /* 0.1.3.6.1.5.5.7.3.8 = "id-kp-Timestamping" */
    {  9, 13, 0,  0,    0, 0x022c }, /* 0.1.3.6.1.5.5.7.3.9 = "id-kp-OCSPSigning" */
    { 10,  3, 0,  0,    0, 0x0b75 }, /* 0.1.3.6.1.5.5.7.3.10 = "id-kp-DVCS" */
    { 11, 12, 0,  0,    0, 0x0304 }, /* 0.1.3.6.1.5.5.7.3.11 = "id-kp-SBGPCertAAServiceAuth" */
    { 13,  6, 0,  0,    0, 0x0839 }, /* 0.1.3.6.1.5.5.7.3.13 = "id-kp-EAPOverPPP" */
    { 14,  4, 0,  0,    0, 0x0a78 }, /* 0.1.3.6.1.5.5.7.3.14 = "id-kp-EAPOverLAN" */
    {  3,  5, 0,  1,  169, 0x09fb }, /* 0.1.3.14.3 = "oiw-ssig" */
    {  2,  3, 0,  8,  170, 0x0b60 }, /* 0.1.3.14.3.2 = "oiw-ssig-algorithms" */
    {  2,  9, 0,  0,    0, 0x0659 }, /* 0.1.3.14.3.2.2 = "oiw-ssig-Md4WithRsa" */
    {  3,  9, 0,  0,    0, 0x0635 }, /* 0.1.3.14.3.2.3 = "oiw-ssig-Md5WithRsa" */
    {  4, 16, 0,  0,    0, 0x0151 }, /* 0.1.3.14.3.2.4 = "oiw-ssig-Md4WithRsaEncryption" */
    { 15,  9, 0,  0,    0, 0x0674 }, /* 0.1.3.14.3.2.15 = "oiw-ssig-ShaWithRsaEncryption" */
    { 24, 16, 0,  0,    0, 0x0141 }, /* 0.1.3.14.3.2.24 = "oiw-ssig-Md2WithRsaEncryption" */
    { 25, 16, 0,  0,    0, 0x0121 }, /* 0.1.3.14.3.2.25 = "oiw-ssig-Md5WithRsaEncryption" */
    { 26,  3, 0,  0,    0, 0x07cc }, /* 0.1.3.14.3.2.26 = "oiw-ssig-Sha1" */
    { 29,  7, 0,  0,    0, 0x07cc }, /* 0.1.3.14.3.2.29 = "oiw-ssig-Sha1WithRsaEncryption" */
    {  1,  5, 0,  0,    0, 0x0980 }, /* 0.2.1 = "asn.1" */
    {  5,  4, 0,  2,  181, 0x099e }, /* 0.2.5 = "x500" */
    { 16, 10, 1,  1,   18, 0x04a7 }, /* 0.2.16 = "by-country" */
    {  4,  8, 0,  6,  183, 0x06c6 }, /* 0.2.5.4 = "x500-attribute-types" */
    { 29,  3, 0, 20,  189, 0x0b84 }, /* 0.2.5.29 = "id-ce" */
    {  3,  3, 0,  0,    0, 0x0b28 }, /* 0.2.5.4.3 = "x500-CommonName" */
    {  6,  3, 0,  0,    0, 0x0b57 }, /* 0.2.5.4.6 = "x500-CountryName" */
    {  7, 10, 0,  0,    0, 0x046b }, /* 0.2.5.4.7 = "x500-LocalityName" */
    {  8, 15, 0,  0,    0, 0x0170 }, /* 0.2.5.4.8 = "x500-StatOrProvinceName" */
    { 10,  3, 0,  0,    0, 0x0bb0 }, /* 0.2.5.4.10 = "x500-OrganizationName" */
    { 11,  7, 0,  0,    0, 0x07f6 }, /* 0.2.5.4.11 = "x500-OrganizationUnitName" */
    {  1,  7, 0,  0,    0, 0x07e1 }, /* 0.2.5.29.1 = "id-ce-AuthorityKeyIdentifier-Deprecated" */
    {  2,  6, 0,  0,    0, 0x08db }, /* 0.2.5.29.2 = "id-ce-KeyAttributes-Deprecated" */
    {  3,  5, 0,  0,    0, 0x0a1e }, /* 0.2.5.29.3 = "id-ce-CertificatePolicies-Deprecated" */
    {  4, 17, 0,  0,    0, 0x00f0 }, /* 0.2.5.29.4 = "id-ce-KeyUsageRestriction-Deprecated" */
    {  7,  9, 0,  0,    0, 0x05ff }, /* 0.2.5.29.7 = "id-ce-SubjectAltName-Deprecated" */
    {  8,  8, 0,  0,    0, 0x070e }, /* 0.2.5.29.8 = "id-ce-IssuerAltName-Deprecated" */
    { 14,  5, 0,  0,    0, 0x0962 }, /* 0.2.5.29.14 = "id-ce-SubjectKeyIdentifier" */
    { 15,  4, 0,  0,    0, 0x00f0 }, /* 0.2.5.29.15 = "id-ce-KeyUsage" */
    { 16, 12, 0,  0,    0, 0x0310 }, /* 0.2.5.29.16 = "id-ce-PrivateKeyUsagePeriod" */
    { 17,  7, 0,  0,    0, 0x05ff }, /* 0.2.5.29.17 = "id-ce-SubjectAltName" */
    { 18, 12, 0,  0,    0, 0x0328 }, /* 0.2.5.29.18 = "id-ce-issuerAltName" */
    { 19,  4, 0,  0,    0, 0x0b0f }, /* 0.2.5.29.19 = "id-ce-BasicConstraints" */
    { 25,  9, 0,  0,    0, 0x0650 }, /* 0.2.5.29.25 = "id-ce-CrlDistributionPoints" */
    { 29,  9, 0,  0,    0, 0x05c9 }, /* 0.2.5.29.29 = "id-ce-CertificateIssuer" */
    { 30,  4, 0,  0,    0, 0x0af7 }, /* 0.2.5.29.30 = "id-ce-NameConstraints" */
    { 31,  9, 0,  0,    0, 0x0650 }, /* 0.2.5.29.31 = "id-ce-CrlDistributionPoints" */
    { 32, 11, 0,  1,  209, 0x041f }, /* 0.2.5.29.32 = "id-ce-CertificatePolicies" */
    { 35,  5, 0,  0,    0, 0x07e1 }, /* 0.2.5.29.35 = "id-ce-AuthorityKeyIdentifier" */
    { 36,  4, 0,  0,    0, 0x0b1b }, /* 0.2.5.29.36 = "id-ce-PolicyConstraints" */
    { 37,  5, 0,  0,    0, 0x0958 }, /* 0.2.5.29.37 = "id-ce-ExtKeyUsage" */
    {  0,  7, 0,  0,    0, 0x07b0 }, /* 0.2.5.29.32.0 = "id-ce-cp-anyPolicy" */
    {  1, 13, 1,  3,   19, 0x02a1 }, /* 0.2.16.840.1 = "usa-company-arc" */
    {  3, 21, 0,  1,  212, 0x0049 }, /* 0.2.16.840.1.101.3 = "usa-computer-security-register" */
    {  4,  2, 0,  3,  213, 0x0bda }, /* 0.2.16.840.1.101.3.4 = "nist-algorithms" */
    {  1,  6, 0,  0,    0, 0x0821 }, /* 0.2.16.840.1.101.3.4.1 = "nist-aes-algorithms" */
    {  2,  7, 0, 12,  216, 0x07c5 }, /* 0.2.16.840.1.101.3.4.2 = "nist-hash-algorithms" */
    {  3,  5, 0, 16,  228, 0x097b }, /* 0.2.16.840.1.101.3.4.3 = "nist-sigAlgs" */
    {  1,  2, 0,  0,    0, 0x0bd4 }, /* 0.2.16.840.1.101.3.4.2.1 = "nist-sha256" */
    {  2,  2, 0,  0,    0, 0x0bd2 }, /* 0.2.16.840.1.101.3.4.2.2 = "nist-sha384" */
    {  3,  2, 0,  0,    0, 0x0aa8 }, /* 0.2.16.840.1.101.3.4.2.3 = "nist-sha512" */
    {  4,  2, 0,  0,    0, 0x0bdc }, /* 0.2.16.840.1.101.3.4.2.4 = "nist-sha224" */
    {  5,  4, 0,  0,    0, 0x0aa8 }, /* 0.2.16.840.1.101.3.4.2.5 = "nist-sha512-224" */
    {  6,  4, 0,  0,    0, 0x0adf }, /* 0.2.16.840.1.101.3.4.2.6 = "nist-sha512-256" */
    {  7,  3, 0,  0,    0, 0x0b7b }, /* 0.2.16.840.1.101.3.4.2.7 = "nist-sha3-224" */
    {  8,  3, 0,  0,    0, 0x0b5a }, /* 0.2.16.840.1.101.3.4.2.8 = "nist-sha3-256" */
    {  9,  3, 0,  0,    0, 0x0b81 }, /* 0.2.16.840.1.101.3.4.2.9 = "nist-sha3-384" */
    { 10,  3, 0,  0,    0, 0x0b49 }, /* 0.2.16.840.1.101.3.4.2.10 = "nist-sha3-512" */
    { 11,  9, 0,  0,    0, 0x0581 }, /* 0.2.16.840.1.101.3.4.2.11 = "nist-shake128" */
    { 12,  9, 0,  0,    0, 0x0611 }, /* 0.2.16.840.1.101.3.4.2.12 = "nist-shake256" */
    {  1,  4, 0,  0,    0, 0x0a64 }, /* 0.2.16.840.1.101.3.4.3.1 = "nist-dsa-with-sha224" */
    {  2,  4, 0,  0,    0, 0x0a58 }, /* 0.2.16.840.1.101.3.4.3.2 = "nist-dsa-with-sha256" */
    {  3,  4, 0,  0,    0, 0x0a54 }, /* 0.2.16.840.1.101.3.4.3.3 = "nist-dsa-with-sha384" */
    {  4,  4, 0,  0,    0, 0x0a74 }, /* 0.2.16.840.1.101.3.4.3.4 = "nist-dsa-with-sha512" */
    {  5,  5, 0,  0,    0, 0x0a0f }, /* 0.2.16.840.1.101.3.4.3.5 = "nist-id-dsa-with-sha224" */
    {  6,  5, 0,  0,    0, 0x0a0a }, /* 0.2.16.840.1.101.3.4.3.6 = "nist-id-dsa-with-sha256" */
    {  7,  5, 0,  0,    0, 0x0a19 }, /* 0.2.16.840.1.101.3.4.3.7 = "nist-id-dsa-with-sha384" */
    {  8,  5, 0,  0,    0, 0x098f }, /* 0.2.16.840.1.101.3.4.3.8 = "nist-id-dsa-with-sha512" */
    {  9,  6, 0,  0,    0, 0x08d5 }, /* 0.2.16.840.1.101.3.4.3.9 = "nist-id-ecdsa-with-sha3-224" */
    { 10,  6, 0,  0,    0, 0x08f9 }, /* 0.2.16.840.1.101.3.4.3.10 = "nist-id-ecdsa-with-sha3-256" */
    { 11,  6, 0,  0,    0, 0x08c9 }, /* 0.2.16.840.1.101.3.4.3.11 = "nist-id-ecdsa-with-sha3-384" */
    { 12,  6, 0,  0,    0, 0x083f }, /* 0.2.16.840.1.101.3.4.3.12 = "nist-id-ecdsa-with-sha3-512" */
    { 13, 10, 0,  0,    0, 0x04cf }, /* 0.2.16.840.1.101.3.4.3.13 = "nist-id-rsassa-pkcs1-v1-5-with-sha3-224" */
    { 14, 10, 0,  0,    0, 0x04e3 }, /* 0.2.16.840.1.101.3.4.3.14 = "nist-id-rsassa-pkcs1-v1-5-with-sha3-256" */
    { 15, 10, 0,  0,    0, 0x04ed }, /* 0.2.16.840.1.101.3.4.3.15 = "nist-id-rsassa-pkcs1-v1-5-with-sha3-384" */
    { 16, 10, 0,  0,    0, 0x04f7 }, /* 0.2.16.840.1.101.3.4.3.16 = "nist-id-rsassa-pkcs1-v1-5-with-sha3-512" */
    {  1,  0, 0, 11,  246, 000000 }, /* 0.2.16.840.1.113730.1 */
    {  4,  0, 0,  1,  257, 000000 }, /* 0.2.16.840.1.113730.4 */
    {  1,  6, 0,  0,    0, 0x08ed }, /* 0.2.16.840.1.113730.1.1 = "netscape-cert-type" */
    {  2,  7, 0,  0,    0, 0x07ef }, /* 0.2.16.840.1.113730.1.2 = "netscape-base-url" */
    {  3,  3, 0,  0,    0, 0x0ba7 }, /* 0.2.16.840.1.113730.1.3 = "netscape-revocation-url" */
    {  4,  4, 0,  0,    0, 0x0a3c }, /* 0.2.16.840.1.113730.1.4 = "netscape-ca-revocation-url" */
    {  7, 11, 0,  0,    0, 0x0409 }, /* 0.2.16.840.1.113730.1.7 = "netscape-cert-renewal-url" */
    {  8,  4, 0,  0,    0, 0x0ae7 }, /* 0.2.16.840.1.113730.1.8 = "netscape-ca-policy-url" */
    {  9,  5, 0,  0,    0, 0x0994 }, /* 0.2.16.840.1.113730.1.9 = "netscape-HomePage-url" */
    { 10,  6, 0,  0,    0, 0x08c3 }, /* 0.2.16.840.1.113730.1.10 = "netscape-EntityLogo" */
    { 11,  9, 0,  0,    0, 0x05ed }, /* 0.2.16.840.1.113730.1.11 = "netscape-UserPicture" */
    { 12, 11, 0,  0,    0, 0x042a }, /* 0.2.16.840.1.113730.1.12 = "netscape-ssl-server-name" */
    { 13,  8, 0,  0,    0, 0x069e }, /* 0.2.16.840.1.113730.1.13 = "netscape-comment" */
    {  1,  9, 0,  0,    0, 0x056f }, /* 0.2.16.840.1.113730.4.1 = "netscape-eku-serverGatedCrypto" */
    {  1,  4, 0,  3,  259, 0x0a70 }, /* 0.2.16.840.1.113733.1 = "verisign-pki" */
    {  6, 12, 0,  1,  262, 0x02d4 }, /* 0.2.16.840.1.113733.1.6 = "verisign-pki-extensions" */
    {  7, 10, 0,  5,  263, 0x0533 }, /* 0.2.16.840.1.113733.1.7 = "verisign-pki-policies" */
    {  8,  0, 0,  1,  276, 000000 }, /* 0.2.16.840.1.113733.1.8 */
    {  7, 12, 0,  0,    0, 0x0334 }, /* 0.2.16.840.1.113733.1.6.7 = "verisign-pki-ext-RolloverID" */
    {  9,  4, 0,  0,    0, 0x0a88 }, /* 0.2.16.840.1.113733.1.7.9 = "verisign-pki-policy-9" */
    { 21,  4, 0,  0,    0, 0x0a6c }, /* 0.2.16.840.1.113733.1.7.21 = "verisign-pki-policy-21" */
    { 23,  6, 0,  5,  268, 0x0803 }, /* 0.2.16.840.1.113733.1.7.23 = "verisign-pki-policy-vtn-cp" */
    { 46,  6, 0,  2,  273, 0x086f }, /* 0.2.16.840.1.113733.1.7.46 = "verisign-pki-policy-cis" */
    { 48,  9, 0,  1,  275, 0x062c }, /* 0.2.16.840.1.113733.1.7.48 = "verisign-pki-policy-thawte" */
    {  1, 11, 0,  0,    0, 0x0435 }, /* 0.2.16.840.1.113733.1.7.23.1 = "verisign-pki-policy-vtn-cp-class1" */
    {  2, 11, 0,  0,    0, 0x0440 }, /* 0.2.16.840.1.113733.1.7.23.2 = "verisign-pki-policy-vtn-cp-class2" */
    {  3, 11, 0,  0,    0, 0x044b }, /* 0.2.16.840.1.113733.1.7.23.3 = "verisign-pki-policy-vtn-cp-class3" */
    {  4, 11, 0,  0,    0, 0x03d2 }, /* 0.2.16.840.1.113733.1.7.23.4 = "verisign-pki-policy-vtn-cp-class4" */
    {  6,  6, 0,  0,    0, 0x0905 }, /* 0.2.16.840.1.113733.1.7.23.6 = "verisign-pki-policy-vtn-cp-6" */
    {  1,  9, 0,  0,    0, 0x05a5 }, /* 0.2.16.840.1.113733.1.7.46.1 = "verisign-pki-policy-cis-type1" */
    {  2,  9, 0,  0,    0, 0x05f6 }, /* 0.2.16.840.1.113733.1.7.46.2 = "verisign-pki-policy-cis-type2" */
    {  1,  9, 0,  0,    0, 0x059c }, /* 0.2.16.840.1.113733.1.7.48.1 = "verisign-pki-policy-thawte-cps-1" */
    {  1, 11, 0,  0,    0, 0x037a }, /* 0.2.16.840.1.113733.1.8.1 = "verisign-pki-eku-IssStrongCrypto" */
};

#if defined(RT_ARCH_AMD64) || defined(RT_ARCH_X86)
# pragma pack(2)
#endif
typedef struct RTOIDENTRYBIG
{
    uint32_t    uKey;
    uint8_t     cchString;
    uint8_t     fBigTable  : 1;
    uint8_t     cChildren  : 7;
    uint16_t    idxChildren;
    uint16_t    offString;
} RTOIDENTRYBIG;
#if defined(RT_ARCH_AMD64) || defined(RT_ARCH_X86)
# pragma pack()
AssertCompileSize(RTOIDENTRYBIG, 10);
#endif
typedef RTOIDENTRYBIG const *PCRTOIDENTRYBIG;

static const RTOIDENTRYBIG g_aBigOidTable[] = 
{
    {     840,  1, 1,  2,    1, 0x0049 }, /* 0.1.2.840 = "usa" */
    {  113549,  6, 0,  1,    4, 0x08e1 }, /* 0.1.2.840.113549 = "rsadsi" */
    {  113635,  0, 1,  1,    3, 000000 }, /* 0.1.2.840.113635 */
    {     100,  0, 0,  3,   55, 000000 }, /* 0.1.2.840.113635.100 */
    {     311,  9, 1, 13,    5, 0x05b7 }, /* 0.1.3.6.1.4.1.311 = "microsoft" */
    {       2, 13, 0,  4,   70, 0x0246 }, /* 0.1.3.6.1.4.1.311.2 = "ms-authenticode" */
    {       3, 13, 0,  2,   98, 0x0287 }, /* 0.1.3.6.1.4.1.311.3 = "ms-timestamping" */
    {      10,  0, 0,  5,  103, 000000 }, /* 0.1.3.6.1.4.1.311.10 */
    {      12,  2, 0,  2,  127, 0x094e }, /* 0.1.3.6.1.4.1.311.12 = "Ms-Catalog" */
    {      15,  5, 0,  0,    0, 0x0a14 }, /* 0.1.3.6.1.4.1.311.15 = "Ms-Java" */
    {      16, 17, 0,  0,    0, 0x00df }, /* 0.1.3.6.1.4.1.311.16 = "Ms-Outlook-Exchange" */
    {      17,  3, 0,  1,  133, 0x0bb6 }, /* 0.1.3.6.1.4.1.311.17 = "Ms-PKCS12-attribute" */
    {      20,  0, 0,  2,  134, 000000 }, /* 0.1.3.6.1.4.1.311.20 */
    {      21, 18, 0,  7,  136, 0x0098 }, /* 0.1.3.6.1.4.1.311.21 = "Ms-CertSrv-Infrastructure" */
    {      40,  2, 0,  0,    0, 0x0bd0 }, /* 0.1.3.6.1.4.1.311.40 = "Ms-Fonts" */
    {      41, 25, 0,  0,    0, 0x0019 }, /* 0.1.3.6.1.4.1.311.41 = "Ms-License-and-Registration" */
    {      42,  5, 0,  0,    0, 0x093a }, /* 0.1.3.6.1.4.1.311.42 = "Ms-CorpPKI" */
    {      88,  3, 0,  0,    0, 0x0b1f }, /* 0.1.3.6.1.4.1.311.88 = "Ms-CapiCom" */
    {     840,  1, 0,  1,  210, 0x0049 }, /* 0.2.16.840 = "usa" */
    {     101, 11, 0,  1,  211, 0x0364 }, /* 0.2.16.840.1.101 = "usa-goverment" */
    {  113730,  8, 0,  2,  244, 0x05e4 }, /* 0.2.16.840.1.113730 = "netscape" */
    {  113733,  8, 0,  1,  258, 0x0593 }, /* 0.2.16.840.1.113733 = "verisign" */
};
